unit fMHA_ASI_Close;

{- Designed by Roger Schultz, Ph.D.
   Mental Health Strategic Health Care Group, Informatics Section
   Revision Date: 6/2001
   Description: This form gives the user several choices when program
                is closed.  -}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  uMHA_MsgDlg,
  RzPanel, RzRadGrp, ExtCtrls, EsGrad;

type
  TfrmASI_Close = class(TForm)
    pnl1: TPanel;
    rgrpExit: TRzRadioGroup;
    procedure rgrpExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    FCloseResponse : Char;
  public
    { Public declarations }
    property  CloseResponse: Char read FCloseResponse;
                             // Letters used are: C-Close, E-Exit, F-Finish later
                             // S-Save/Verify/Sign it
  end;

var
  frmASI_Close: TfrmASI_Close;

implementation

{$R *.DFM}

uses
  fMHA_Main;

procedure TfrmASI_Close.rgrpExitClick(Sender: TObject);
begin
  Case rgrpExit.ItemIndex of
    0 : FCloseResponse := 'C';  // cancel, return to program
    1 : begin
          if MsgDlg('Are you sure you want to exit this ASI without saving?',
            'Addiction Serverity Index',
            mtConfirmation, [mbYes, mbNo],
            0) = mrNo then
              begin
                rgrpExit.ItemIndex := -1;
                exit;
              end;
          FCloseResponse := 'E';  // exit now, do not save anything
        end;
    2 : FCloseResponse := 'F';  // finish later, save but do not sign
    3 : FCloseResponse := 'S';  // save and sign, perhaps verify
  end;// case
  Close;
end;

procedure TfrmASI_Close.FormCreate(Sender: TObject);
var
  WhereMouse : TPoint;
begin
// Place the mouse in the response box, item 2
  WhereMouse.X := Screen.Width  div 2;
  WhereMouse.Y := Screen.Height div 2;
  Mouse.CursorPos := WhereMouse;
  ShowModal;
end;

procedure TfrmASI_Close.FormKeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
    'S','s' : FCloseResponse := 'S';  // save, verify, sign it
    'F','f' : FCloseResponse := 'F';  // finish later
    'E','e' : begin
                if MsgDlg('Are you sure you want to exit this ASI without saving?',
                  'Addiction Serverity Index',
                  mtConfirmation, [mbYes, mbNo],
                  0) = mrNo then
                    begin
                      rgrpExit.ItemIndex := -1;
                      exit;
                    end;
                  FCloseResponse := 'E';  // exit now
              end;
    'C','c' : FCloseResponse := 'C';  // close/cancel, return to program
  end; // case
  Close;
end;

end.
