unit fMHA_ASI_Sign;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ORFn,
  rCore, Hash;

type
  TfrmASISign = class(TForm)
    txtESCode: TEdit;
    lblESCode: TLabel;
    cmdOK: TButton;
    cmdCancel: TButton;
    lblText: TLabel;
    procedure cmdOKClick(Sender: TObject);
    procedure cmdCancelClick(Sender: TObject);
  private
    FESCode: string;
  public
    { Public declarations }
  end;

procedure SignatureForASI(FontSize: Integer; const AText, ACaption: string; var ESCode: string);

implementation

{$R *.DFM}

const
  TX_INVAL_MSG = 'Not a valid electronic signature code.  Enter a valid code or press Cancel.';
  TX_INVAL_CAP = 'Unrecognized Signature Code';

procedure SignatureForASI(FontSize: Integer; const AText, ACaption: string; var ESCode: string);
var
  frmASISign: TfrmASISign;
begin
  frmASISign := TfrmASISign.Create(Application);
  try
    with frmASISign do
    begin
      FESCode := '';
      Caption := ACaption;
      lblText.Caption := AText;
      ShowModal;
      ESCode := FESCode;
    end;
  finally
    frmASISign.Release;
  end;
end;

procedure TfrmASISign.cmdOKClick(Sender: TObject);
begin
  FESCode := Encrypt(txtESCode.Text);
  Close;
end;

procedure TfrmASISign.cmdCancelClick(Sender: TObject);
begin
  FESCode := '';
  Close;
end;

end.
