unit fMHA_AppendTestComments;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfrmAppendTestComments = class(TForm)
    memComments: TMemo;
    pnlButtons: TPanel;
    btnSave: TButton;
    btnCancel: TButton;
    pnlTestID: TPanel;
    lblTest: TLabel;
    procedure btnCancelClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure memCommentsChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmAppendTestComments: TfrmAppendTestComments;

implementation

{$R *.DFM}
uses
  ORfn,
  ORNet,
  uCore,
  TRPCB,
  fMHA_Main;

procedure TfrmAppendTestComments.btnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmAppendTestComments.FormActivate(Sender: TObject);
begin
  btnSave.Enabled := false;
  memComments.Clear;

  Caption := MixedCase(Patient.Name) + '   SSN: ' + Patient.SSN;
  lblTest.Caption := 'Test Date: '
    + frmMain.grdTestResults.Cells[0, frmMain.grdTestResults.Row]
    + '   Test: ' + frmMain.grdTestResults.Cells[1, frmMain.grdTestResults.Row];
end;

procedure TfrmAppendTestComments.btnSaveClick(Sender: TObject);
Var
  AdminDate,
  TestCode,
  tempString: String;
  i: Integer;
begin
     {*Date of comment = Now,
     author = user.dfn (or user.name?)
     test record iens = ???
     date of administration = frmMain.grdTestResults.Cells[0, frmMain.grdTestResults.Row]
     test name = frmMain.grdTestResults.Cells[1, frmMain.grdTestResults.Row]
     comment = memComments.Text*}

  AdminDate := FloatToStr(DateTimeToFMDateTime(StrToDate(
    frmMain.grdTestResults.Cells[0, frmMain.grdTestResults.Row])));

  TestCode := frmMain.grdTestResults.Cells[1, frmMain.grdTestResults.Row];

  with RPCBrokerV do begin
    ClearResults := True;
    ClearParameters := True;
    RemoteProcedure := 'YTAPI SAVE TEST COMMENT';

    {value = DFN^DUZ^DATE?TIME^TEST NAME(CAGE for example)^AUTHOR^MEMO.lines.count}
    Param[0].Value := Patient.DFN +'^' +
                      IntToStr(User.duz) + '^' +
                      AdminDate + '^' +
                      TestCode + '^' +
                      IntToStr(user.duz) + '^' +
                      IntToStr(memComments.Lines.count);
    Param[0].PType := Literal;
    for i := 0 to memComments.Lines.count-1 do
      begin
        tempString := '"'+IntToStr(i+1)+'"';
        Param[1].Mult[tempString] := memComments.Lines[i];
      end;
    Param[1].PType := List;
    call;
  end;
  Close;
end;

procedure TfrmAppendTestComments.memCommentsChange(Sender: TObject);
begin
  If memComments.Text = '' then btnSave.Enabled := False
  else btnSave.Enabled := True;

end;

procedure TfrmAppendTestComments.FormCreate(Sender: TObject);
var r: TRect;
begin
  //set form top and height to work area (i.e., desktop size minus task bars)
  SystemParametersInfo(SPI_GetWorkArea, 0, @r, 0);
  BoundsRect := r;
  Top := r.Top;
  Height := r.Bottom - r.Top;

  //set form width to 638 and center it
  Width := 638;
  Left := (r.Right - Width) div 2;


end;

procedure TfrmAppendTestComments.FormKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (Key = vk_Escape) then
    Close;
end;

end.

