{***************************************************************

 UNIT NAME: fMHA_Main
 PACKAGE: Mental Health Assistant
 WARNING:
 DATE CREATED: Sep, 2000
 SITE NAME: Salt Lake City Mental Health Informatics Section
 DEVELOPERS: Cannon/Feldman/Schultz/Hsu/Finkelstein
 DESCRIPTION:
 NOTE: This unit requires Mental Health patch 71, or greater, in
       order to run.

 HISTORY  :

 Required third-party Delphi components and libraries:

  LMDPack
  GPVersion
  CPRS
  Delphi FileMan Components
  Raize
  TMS

****************************************************************

 NOTES:

   - Determine lowest visibility for all methods, fields and properties.
   - Is the class a business rule, or a GUI method?

****************************************************************}

unit fMHA_Main;

interface

uses
  Windows, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, Grids, ExtCtrls, Buttons, CheckLst, ComCtrls, Vawrgrid,
  TeEngine, Series, TeeProcs, Chart, AdvGrid,

  //Business objects
  uMHA_Registry, uMHA_Entities, uMHA_SessionControl, uMHA_MHInstruments,

  RXCtrls, Spin, Tabs,
  ORCtrls, RxGIF, LMDCustomComponent, LMDOneInstance, Fmcntrls, SysUtils,
  LMDSysInfo, LMDCustomButton, LMDButton, BaseGrid;

type
  TfrmMain = class(TForm)
    mnuMain: TMainMenu;
    mnuFile: TMenuItem;
    mnuSelectPt: TMenuItem;
    N1: TMenuItem;
    mnuExit: TMenuItem;
    stsbrMain: TStatusBar;
    pnlButtons: TPanel;
    pgctrlMain: TPageControl;
    tbshtTestResults: TTabSheet;
    tbshtOrderTests: TTabSheet;
    tbshtGAF: TTabSheet;
    tbshtASI: TTabSheet;
    pnlOldTests: TPanel;
    pnlTestResults: TPanel;
    chrtTests: TChart;
    spltTestResults: TSplitter;
    Series1: TLineSeries;
    pnlGrdTestResults: TPanel;
    pnlIncompleteTests: TPanel;
    pnlNewGAF: TPanel;
    lblEnterGAF: TLabel;
    lblDate: TLabel;
    pnlAllGAFCriteria: TPanel;
    grdGAFCriteria: TVAWrapGrid;
    pnlOldGAF: TPanel;
    spltGAF: TSplitter;
    pnlGAFCriterion: TPanel;
    lblGAFSingleCriterion: TStaticText;
    chrtGAF: TChart;
    Series2: TLineSeries;
    pnlOldASIOuter: TPanel;
    pnlOldASIInner: TPanel;
    grdOldASI: TAdvStringGrid;
    Label7: TLabel;
    memTestResults: TRichEdit;
    grdGAFResults: TAdvStringGrid;
    rgrpSortTests: TRadioGroup;
    mnuHelp: TMenuItem;
    mnuAbout: TMenuItem;
    N2: TMenuItem;
    grpOrderer: TGroupBox;
    cbxOrderedBy: TORComboBox;
    grpBattery: TGroupBox;
    grpIncompleteTests: TGroupBox;
    grpTestChoices: TGroupBox;
    lstTestChoices: TORListBox;
    pnlOrderButtons: TPanel;
    grpTestsChosen: TGroupBox;
    lstTestsChosen: TORListBox;
    mnuReports: TMenuItem;
    mnuGraphs: TMenuItem;
    N3: TMenuItem;
    mnuPrintReport: TMenuItem;
    mnuCopyReport: TMenuItem;
    mnuSaveReportAs: TMenuItem;
    mnuPrintGraph: TMenuItem;
    mnuCopyGraph: TMenuItem;
    mnuSaveGraphAs: TMenuItem;
    spltASIReports: TSplitter;
    pnlASIReport: TPanel;
    memASIReport: TRichEdit;
    pnlASITrends: TPanel;
    spltASITrends: TSplitter;
    chrtASITrends: TChart;
    Series3: TLineSeries;
    dtpkrEval: TDateTimePicker;
    grdTestResults: TAdvStringGrid;
    spnedtGAF: TSpinEdit;
    grdIncompleteTests: TAdvStringGrid;
    grdASITrends: TAdvStringGrid;
    pnlASIReportOptions: TPanel;
    rgrpASIReportOption: TRadioGroup;
    lblASIReminder: TStaticText;
    mnuPopUp: TPopupMenu;
    mnuReportsPU: TMenuItem;
    mnuGraphsPU: TMenuItem;
    mnuCopyReportPU: TMenuItem;
    mnuPrintReportPU: TMenuItem;
    mnuSaveReportPU: TMenuItem;
    mnuCopyGraphPU: TMenuItem;
    mnuPrintGraphPU: TMenuItem;
    mnuSaveGraphPU: TMenuItem;
    mnuShowHints: TMenuItem;
    mnuTools: TMenuItem;
    lstTestBatteries: TORListBox;
    lblGAFCopyright: TStaticText;
    mnuTestInfo: TMenuItem;
    mnuStartTab: TMenuItem;
    mnuDefaultFormSizes: TMenuItem;
    LMDOneInstance1: TLMDOneInstance;
    FMMemoGAFInError: TFMMemo;
    btnEditASI: TButton;
    mnuTestInfoPU: TMenuItem;
    mnuActions: TMenuItem;
    mnuTestResults: TMenuItem;
    mnuOrderTests: TMenuItem;
    mnuASI: TMenuItem;
    mnuGAF: TMenuItem;
    mnuMultiScaleGraphs: TMenuItem;
    mnuEnlargeReport: TMenuItem;
    mnuAppendComments: TMenuItem;
    mnuStaffEntry: TMenuItem;
    mnuClerkEntry: TMenuItem;
    mnuPatientEntry: TMenuItem;
    mnuNewASI: TMenuItem;
    mnuDomainScores: TMenuItem;
    mnuItemTrends: TMenuItem;
    mnuPreviousRatings: TMenuItem;
    mnuSaveRating: TMenuItem;
    mnuEditRating: TMenuItem;
    mnuGAFDue: TMenuItem;
    mnuGoTo: TMenuItem;
    mnuPatientDemographics: TMenuItem;
    N4: TMenuItem;
    mnuSelectAvailableTest: TMenuItem;
    mnuSelectBattery: TMenuItem;
    mnuDeleteOneTest: TMenuItem;
    mnuDeleteAllTests: TMenuItem;
    LMDSysInfo1: TLMDSysInfo;
    btn1: TButton;
    btn2: TButton;
    btn3: TButton;
    btnGAFDue: TBitBtn;
    btnPatient: TLMDButton;
    btnSelectTest: TButton;
    btnDeleteTest: TButton;
    btnDeleteAll: TButton;
    btnBattery: TButton;
    mnuDeleteOneTestPU: TMenuItem;
    mnuDeleteAllTestsPU: TMenuItem;
    mnuSelectAvailableTestPU: TMenuItem;
    mnuBtn1PU: TMenuItem;
    mnuBtn2PU: TMenuItem;
    mnuBtn3PU: TMenuItem;
    mnuGafDuePU: TMenuItem;
    N5: TMenuItem;
    mnuRefresh: TMenuItem;
    mnuSelectPatientPU: TMenuItem;
    mnuRefreshPU: TMenuItem;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure mnuSelectPtClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbxOrderedByNeedData(Sender: TObject;
      const StartFrom: string; Direction, InsertAt: Integer);
    procedure cbxOrderedByChange(Sender: TObject);
    procedure DisplayPrevTests(Sender: TObject);
    procedure GAFReminder;
    procedure DisplayViewingPriviledge;
    procedure grdTestResultsClick(Sender: TObject);
    procedure GraphTestData;
    procedure pgctrlMainChange(Sender: TObject);
    procedure btnSelectTestClick(Sender: TObject);
    procedure SetTestSelectionButtons;
    procedure btnDeleteTestClick(Sender: TObject);
    procedure btnDeleteAllClick(Sender: TObject);
    procedure lstTestsChosenDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure lstTestsChosenDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure lstTestsChosenMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure DisplayPrevGAFs;
    procedure LoadGAFCriteria;
    procedure spnedtGAFChange(Sender: TObject);
    procedure grdGAFCriteriaClick(Sender: TObject);
    procedure GraphGAFData;
    procedure SortTests;
    procedure InitgrdOldASI;
    procedure DisplayPrevASI;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure rgrpSortTestsClick(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure DisplayIncompleteTests;
    procedure InitgrdGAFResults;
    procedure ASITrends;
    procedure rgrpASIReportOptionClick(Sender: TObject);
    procedure InitgrdASITrends;
    procedure grdASITrendsClick(Sender: TObject);
    procedure GafNotDue;
    procedure ShowOldGafRatings;
    procedure mnuExitClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CheckForMultiScale;
    procedure cbxOrderedByExit(Sender: TObject);
    procedure grdIncompleteTestsGetCellColor(Sender: TObject; ARow,
      ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
    procedure spnedtGAFKeyPress(Sender: TObject; var Key: Char);
    procedure UpdateFullTestList;
    procedure grdTestResultsGetCellColor(Sender: TObject; ARow,
      ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
    procedure DisplayOrderingPriviledge;
    procedure grdOldASIClick(Sender: TObject);
    procedure StartTestEntry;
    procedure mnuCopyReportClick(Sender: TObject);
    procedure mnuCopyGraphClick(Sender: TObject);
    procedure mnuPrintGraphClick(Sender: TObject);
    procedure mnuPrintReportClick(Sender: TObject);
    procedure mnuSaveGraphAsClick(Sender: TObject);
    procedure ASIReminder;
    procedure grdASITrendsClickCell(Sender: TObject; arow, acol: Integer);
    procedure mnuSaveReportAsClick(Sender: TObject);
    procedure mnuShowHintsClick(Sender: TObject);
    procedure StartUnsignedASI;
    procedure grdOldASIDblClick(Sender: TObject);
    procedure lstTestChoicesClick(Sender: TObject);
    procedure SetupTabs(Sender: TObject);
    procedure MCMI2;
    procedure lstTestBatteriesDblClick(Sender: TObject);
    procedure lstTestBatteriesClick(Sender: TObject);
    procedure mnuTestInfoClick(Sender: TObject);
    procedure ResizeGAFCriteria;
    procedure FormResize(Sender: TObject);
    procedure grdIncompleteTestsDblClick(Sender: TObject);
    procedure DisablePrimaryButtonsAndMenus;
    procedure ClearSecondaryButtonsAndMenus;
    procedure InitGrdTestResults;
    procedure SetASIGraphButtons;
    procedure PositionTopButtons;
    function ContextID(tmpName: string): integer;
    procedure SignASI_MV;

    (*CPRS code begin*)
    function TimeoutCondition: boolean;
    function GetTimedOut: boolean;
    procedure TimeOutAction;
    procedure mnuStartTabClick(Sender: TObject);
    procedure mnuDefaultFormSizesClick(Sender: TObject);
    procedure lstTestsChosenClick(Sender: TObject);
    procedure grdGAFResultsClick(Sender: TObject);
    procedure grdGAFResultsGetCellColor(Sender: TObject; ARow,
      ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
    procedure btnEditASIClick(Sender: TObject);
    procedure mnuGAFClick(Sender: TObject);
    procedure mnuTestResultsClick(Sender: TObject);
    procedure mnuOrderTestsClick(Sender: TObject);
    procedure mnuASIClick(Sender: TObject);
    procedure lstTestChoicesKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lstTestsChosenKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lstTestBatteriesKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnGAFDueClick(Sender: TObject);
    procedure btn2Click(Sender: TObject);
    procedure btn3Click(Sender: TObject);
    procedure btn1Click(Sender: TObject);
    procedure btnPatientClick(Sender: TObject);
    procedure FormContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure mnuRefreshClick(Sender: TObject);
    (*CPRS end*)

  private
    { Private declarations }
    FCreateProgress: Integer; //CPRS
    FTerminate: Boolean;
    FFirstTestResults, FFirstOrderTab, FFirstGAFTab, FHasYSP, FspnGAFChange:
    Boolean;
    FPartial_ASI: Char;
    FASI_Crash: boolean;
    FASI_RecoveryFile: string;

    FSecureDesktopAvailable: BOOLEAN;

    { BEGIN CPRS Tools menu}
//    CPRSHandle: HWND;
    FVistaMsg: Word;
    procedure DefaultHandler(var Message); override;
    { END CPRS Tools menu}

    procedure SaveLocationAndSize;
    procedure AdjustForm;
    procedure StatusBarMsg(Panel: integer; Msg: string);
    procedure InitASIEditBtn;
    function ASIIsCompleted(RowNum: integer): BOOLEAN;
    //   procedure SetSecondaryPopUpMenus;

  public
    { Public declarations }
    FFirstASITab: Boolean;
    property Partial_ASI: Char read FPartial_ASI write FPartial_ASI;
    property ASI_Crash: boolean read FASI_Crash write FASI_Crash;
    property ASI_RecoveryFile: string read FASI_RecoveryFile write
    FASI_RecoveryFile;

  end;

  {This enumerated type is used to determine which data entry form is active
  just prior to a CPRS-type timeout event. The type could be used for other
  purposes.}
  TCurrentEntryMode = (emNone, emStaff, emClerk, emPatient, emASI);

const
  (*CPRS code Begin*)
  TX_IN_USE = 'Mental Health Assistant in use by: ';
  //  FCP_UPDATE  = 10;// form create about to check auto-update
  FCP_SETHOOK = 20; // form create about to set timeout hooks
  FCP_SERVER = 30; // form create about to connect to server
  FCP_CHKVER = 40; // form create about to check version
  FCP_OBJECTS = 50; // form create about to create core objects
  FCP_FORMS = 60; // form create about to create child forms
  FCP_PTSEL = 70; // form create about to select patient
  FCP_FINISH = 99; // form create finished successfully
  (*CPRS code End*)

  DlgCaption = 'Mental Health Assistant';
  G12OK = 'Interview Completed';

var
  frmMain: TfrmMain;

  CrashedTestRecoveryFile: TextFile;

  //Business objects
  MHTest: TMHTest;
  CompletedTest: TCompletedTest;
  TestItem: TTestItem;
  TestEngine: TTestEngine;
  TestList: TTestList;
  PatientSubSession: TPatientSubSession;
  TestOrderer: TTestOrderer;
  MHA_Registry: TMHA_Registry;
  UserSession: TUserSession;

  CurrentEntryMode: TCurrentEntryMode;

  GraphBothMMPITypes: BOOLEAN;

implementation

uses
  TRPCB, //for RPCBroker functions
  ORfn, //for "mixedcase"
  ORNet, //for CPRS M connectivity stuff
  uCore, //for CPRS core objects: patient, user, etc.
  rCore, //for CPRS functions
  fFrame, //for CPRS code initialization
  fptSel, //CPRS patient-selection form
  ESBDates, //Freeware, we use DaysApart in GAFReminder
  uMHA_DM, // Datamodule that holds Fileman components.
  rMHA_VISTA, // VistA database interfacing functions for our custom objects.
  SplVista, //for Vista splash screen
  fMHA_About, //About Box
  uMHA_MsgDlg, // for message dialogs

  //RPC Broker units
  MFUNSTR, // For MUMPS functions. Piece, etc.
  RPCConf1,

  uInit, // Vista time-out
  fMHA_TestEntry, {PtDemo, PatientDemo,}
  fMHA_PatientDemographics,
  Printers,
  fMHA_ASI_Main,
  fMHA_ASI_Sign,
  fMHA_Options,
  fMHA_TestGraph,
  fMHA_TestReport,
  fMHA_ClerkEntry,
  fMHA_MCMI2, fMHA_AppendTestComments, fMHA_EditGAF, uMHA_ASI_Save;

{$R *.DFM}

function TfrmMain.TimeoutCondition: boolean; //from CPRS
begin
  Result := (FCreateProgress < FCP_PTSEL);
end;

function TfrmMain.GetTimedOut: boolean; //from CPRS
begin
  Result := uInit.TimedOut;
end;

procedure TfrmMain.TimeOutAction; //from CPRS
begin
  case CurrentEntryMode of

    emNone:
      begin
      end; //Nothing happens

    emPatient:
      begin
        TestEngine.SaveTestResults;
        frmTestEntry.Close;
      end;

    emStaff, emClerk:
      TestEngine.SaveTestResults;

    emASI:
      frmASI.ASITimedOut;

  end;
  Close;
end;

{ BEGIN CPRS Tools menu}

procedure TfrmMain.DefaultHandler(var Message); //FOR Conversations with CPRS
{ adds check to the message handling for this form to get a registered message }
var
  buf: array[0..255] of Char;
  CPRSMessageText: ShortString;
  ConvDOB: string;

  procedure HandleOpenWork;
  var
    i: Integer;
  begin

    // Iterate Forms looking for open forms and dialogs
    for I := 0 to Screen.FormCount - 1 do { Iterate }
    begin

      if (Screen.Forms[i].ClassName = 'TMessageForm')
        or (Screen.Forms[i].ClassName = 'TfrmASI_Close')
        or (Screen.Forms[i].ClassName = 'TfrmTestGraph')
        or (Screen.Forms[i].ClassName = 'TfrmReport')
        or (Screen.Forms[i].ClassName = 'TfrmEditGAF')
        or (Screen.Forms[i].ClassName = 'TfrmASI_Options')
        or (Screen.Forms[i].ClassName = 'TfrmASISign')
        or (Screen.Forms[i].ClassName = 'TfrmPatientDemographics')
        or (Screen.Forms[i].ClassName = 'TfrmMHA_About') then
        Screen.Forms[i].ModalResult := mrCancel;

      if Screen.Forms[i].ClassName = 'TfrmTestEntry' then
      begin
        TestEngine.SaveTestResults;
        Screen.Forms[i].ModalResult := mrCancel;
      end;

      if Screen.Forms[i].ClassName = 'TfrmASI' then
      begin
        ASI_Save.SaveASIData; // uMHA_ASI_Save
        Screen.Forms[i].ModalResult := mrCancel;
      end;

      if Screen.Forms[i].ClassName = 'TfrmAppendTestComments' then
      begin
        frmAppendTestComments.btnSaveClick(Self);
        Screen.Forms[i].ModalResult := mrCancel;
      end;

      if Screen.Forms[i].ClassName = 'TfrmCE' then
      begin
        TestEngine.SaveTestResults;
        Screen.Forms[i].ModalResult := mrCancel;
      end;

    end; //for I := 0 to Screen.FormCount - 1 do

   UserSession.CPRSPatientChanged := False;

  end; { OpenWorkExists }

begin {  TfrmMain.DefaultHandler  }
  // do the default message handling
  inherited DefaultHandler(Message);

  if not (UserSession = nil) then
    if not UserSession.IsCPRSTool then
      exit;

  // if the message is 'VistA Event - Clinical' and not posted from self...
  // wParam=Handle of message sender, lParam=entry in global atom table
  with TMessage(Message) do
    if (Msg = FVistaMsg) and (wParam <> Handle) then
    begin
      // retrieve the text pointed to by lParam into a buffer
      GlobalGetAtomName(lParam, buf, 255);
      CPRSMessageText := StrPas(buf);

      //Make sure we are talking to CPRS
      if UserSession.CPRSHandle <> wParam then
        ShowMessage('MHA ERROR: CPRS wParam mismatch');

      // debug ShowMessage(CPRSMessageText);

      //CPRS changed Selected Patient
      if (Piece(CPRSMessageText, '^', 1) = 'XPT') and
        (Piece(CPRSMessageText, '^', 2) = 'CPRS') then
      begin
        UserSession.CPRSPatientChanged :=
          not (UserSession.CPRSPatientDFN = Piece(CPRSMessageText, '^', 3));

        if not UserSession.CPRSPatientChanged then
          Exit;

        HandleOpenWork;

        //Assign pt selected in CPRS to our own.
        UserSession.CPRSPatientDFN := Piece(CPRSMessageText, '^', 3);
        //Invoke Select patient
        mnuSelectPt.Click;

        (*        //DBG ShowMessage('Patient Selected: ' + CPRSMessageText);
                FPtdata.IENS := Piece(CPRSMessageText, '^', 3);
                FPtdata.Name := Piece(CPRSMessageText, '^', 6);
                FPtdata.SSN := Piece(CPRSMessageText, '^', 4);
        *)
      end;

      //Handle... CPRS is closing. Close MHA as well.
      if (Piece(CPRSMessageText, '^', 1) = 'END') and
        (Piece(CPRSMessageText, '^', 2) = 'CPRS') then
      begin
        //        Application.Terminate;
        close; {Application}
      end;

    end;
end;
{ END CPRS Tools menu}

  { BEGIN CPRS Tools menu}
  { END CPRS Tools menu}

procedure TfrmMain.FormCreate(Sender: TObject);
//******************************************************************************
// PURPOSE: Create the form and business objects
//******************************************************************************

begin

  //Create MH GUI business objects
  MHTest := TMHTest.Create;
  CompletedTest := TCompletedTest.Create;
  TestItem := TTestItem.Create;
  TestList := TTestList.Create;
  TestEngine := TTestEngine.Create;
  PatientSubSession := TPatientSubSession.Create;
  TestOrderer := TTestOrderer.Create;
  UserSession := TUserSession.Create;

  FSecureDesktopAvailable := FileExists(ExtractFilePath(Application.ExeName)
    +
    'YS_MHA_SD.exe');
  { BEGIN CPRS Tools menu}

  if ParamCount = 5 then
  begin
    UserSession.IsCPRSTool := True;
    // register the message with windows to get a unique message number
    FVistaMsg := RegisterWindowMessage('VistA Event - Clinical'); //FOR CPRS

    //Get parameters from CPRS
      //Don't parse these because they will be parsed by CPRS code.
    UserSession.CPRSBrokerServer := ParamStr(1);
    UserSession.CPRSBrokerListenerPort := ParamStr(2);

    UserSession.CPRSPatientDFN := Piece(ParamStr(3), '=', 2);
    UserSession.CPRSFDUZ := Piece(ParamStr(4), '=', 2);
    UserSession.CPRSFMREF := Piece(ParamStr(5), '=', 2);

    // Debug   ShowMessage(UserSession.CPRSBrokerServer + #13#10 +
    //      UserSession.CPRSBrokerListenerPort + #13#10 +
    //      UserSession.CPRSPatientDFN + #13#10 +
    //      UserSession.CPRSFDUZ + #13#10 +
    //      UserSession.CPRSFMREF);

    {
      We have to init the handle here because CPRS would send us it's handle upon
      start of CPRS, which is too late for applications run from the MH toolbar.
      We later verify that this is the correct handle via the FVista message.
    }
      //Init the handle
    UserSession.CPRSHandle := FindWindow('TfrmFrame', nil);
    UserSession.CPRSPatientChanged := false;
    //CPRS. tfrmFrame may change in
  // future CPRS versions. In which case we will be SOL.

(*
  if UserSession.CPRSHandle = 0 then begin
    ShowMessage('MHA ERROR: Unable to access CPRS. You must start CPRS before'
      + ' using this program.');
    //Application.Terminate;
    frmMHToolsMain.Close;
  end
  else
  begin
   {get the window rectangle coordinates}
   Windows.GetWindowRect(UserSession.CPRSHandle, WinRect);

   {Place Toolbar right on top of CPRS}
   frmMHToolsMain.Top := WinRect.Top + 25;
   frmMHToolsMain.Left := WinRect.Left + 150;
  end;
*)

  end
  else {ParamCount = 5}
  begin
    UserSession.IsCPRSTool := False;
  end;

  { END CPRS Tools menu}

  (*CPRS code Begin*)
  // setup initial timeout here so can timeout logon
  FCreateProgress := FCP_SETHOOK;
  InitTimeOut(TimeoutCondition, TimeOutAction);
  (*CPRS code End*)
  // Setup the Windows Registry  in uRegistry
  MHA_Registry := TMHA_Registry.Create;
  // Read default settings stored in Windows Registry
  MHA_Registry.ReadRegistry;

  //Figure out whether to use default form sizes or the sizes at the end
  //of the previous session
  mnuDefaultFormSizes.Checked := MHA_Registry.UseDefaultWindow;

  AdjustForm;

  CurrentEntryMode := emNone;
  Application.OnHint := ShowHint;
end;

procedure TfrmMain.FormShow(Sender: TObject);
//******************************************************************************
// PURPOSE: Close if no connection, create CPRS objects, call pt selection
//          and display viewing priviledge
//******************************************************************************
begin
  (*CPRS code Begin*)
  // connect to the server and create an option context
  FCreateProgress := FCP_SERVER;

  //Select a server, connect to VistA, and log on using CPRS context.
  if not ConnectToServer('OR CPRS GUI CHART') then
  begin
    Close;
    Exit;
  end;

  // create CPRS core objects
  FCreateProgress := FCP_OBJECTS;
  User := TUser.Create;
  Patient := TPatient.Create;
  Encounter := TEncounter.Create;
  Changes := TChanges.Create;
  Notifications := TNotifications.Create;

  //  { BEGIN CPRS Tools menu}
  //
  //  if UserSession.IsCPRSTool then
  //  begin
  //  end;
  //  { END CPRS Tools menu}
  //
    //Determine whether user has YSP key
    //FHasYSP := User.HasKey('YSP');
  FHasYSP := personhaskey(user.duz, 'YSP');

  //Private variable used in spnGAFChange and grdGAFCriteriaClick
  FspnGAFChange := False;

  Caption := TX_IN_USE + MixedCase(User.Name) + '  (' + RPCBrokerV.Server +
    ')';
  (*CPRS code End*)

  //Application show hint set to registry value
  mnuShowHints.Checked := MHA_Registry.ShowAllHints;
  Application.ShowHint := mnuShowHints.Checked;
  Application.HintHidePause := 10000; //duration of pop-up hints in ms

  Application.HelpFile := ExtractFilePath(Application.EXEName) +
    'YS_MHA.hlp';

  //See if a previously-interrupted test file exists. If so, upload.
  TestEngine.TestRecoveryFileName := UserSession.TempFolderName +
    'TEST_Recovery_' + RPCBrokerV.Server + '.txt';
  if FileExists(TestEngine.TestRecoveryFileName) then
  begin
    //A test crash file is there
    MsgDlg('The last termination of this program was not conducted properly '
      +
      '(e.g., power outage, improper shutdown). ' +
      'The data will now be saved. This may take a moment to complete.',
      DlgCaption, mtInformation, [mbOK], 0);
    TestEngine.TestRecoveryFileExists := true;
    TestEngine.LoadCrashFile;
  end;

  // ASI Crash Recovery. If crash file exists then recover the lost data.
  FASI_RecoveryFile := UserSession.TempFolderName +
    'ASI_Recovery_' + RPCBrokerV.Server + '.txt';
  // if this file exists, it means there's been a crash on this server
  if FileExists(FASI_RecoveryFile) then
  begin
    //A test crash file is there
    MsgDlg('The last termination of this program was not conducted properly '
      +
      '(e.g., power outage, improper shutdown). ' +
      'The data will now be saved. This may take a moment to complete.',
      DlgCaption, mtInformation, [mbOK], 0);
    FASI_Crash := true;
    try
      CurrentEntryMode := emASI;
      frmASI := TfrmASI.Create(Self);
      frmASI.FormActivate(Self);
    finally
      frmASI.Free;
      CurrentEntryMode := emNone;
    end;

    FASI_Crash := false;
    if FileExists(FASI_RecoveryFile) then
      DeleteFile(FASI_RecoveryFile);
  end;

  // set the timeout to DTIME now that there is a connection
  UpdateTimeOutInterval(User.DTIME * 1000); // DTIME * 1000 mSec

  FCreateProgress := FCP_PTSEL;
  //  PostMessage(Handle, UM_INITIATE, 0, 0);    // select patient after main form is created

  //Select patient
  mnuSelectPt.Click;

  FCreateProgress := FCP_FINISH;

  //Shutdown splash form
  SplashClose(2000);
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
//******************************************************************************
// PURPOSE: Free objects upon form destruction
//******************************************************************************
begin

  (*CPRS code Begin*)
  Notifications.Free;
  Changes.Free;
  Encounter.Free;
  Patient.Free;
  User.Free;
  (*CPRS code End*)

  // Destroy MH GUI business objects
  UserSession.Free;
  TestOrderer.Free;
  PatientSubSession.Free;
  TestEngine.Free;
  TestList.Free;
  TestItem.Free;
  CompletedTest.Free;
  MHTest.free;
  MHA_Registry.Free;
end;

procedure TfrmMain.DisplayViewingPriviledge;
//******************************************************************************
// PURPOSE: Displays whether user can see all tests or just exempt tests
//******************************************************************************
var
  tmpName: string;
begin
  //get user name, convert it to proper capitalization in First Last order
  tmpName := MixedCase(Piece(User.Name, ',', 2) + ' ' + Piece(User.Name,
    ',',
    1));

  if FHasYSP then
  begin
    StatusBarMsg(0, ' ');
    StatusBarMsg(1, '  ' + tmpName + ' may view the results of all tests.');
  end
  else
  begin
    StatusBarMsg(0, ' Tests listed in gray font are not exempt.');
    StatusBarMsg(1, '  ' + tmpName +
      ' may view the results of exempt tests.');
  end;

end;

procedure TfrmMain.DisplayPrevTests(Sender: TObject);
//******************************************************************************
// PURPOSE: Populate stringgrid with previous tests names and dates
//******************************************************************************
var
  itests, irow, icol: integer;
begin
  irow := 1;

  //Load test names and dates of previous tests
  PatientSubSession.ListOfPreviousTests.Clear;
  PatientSubSession.ListOfPreviousTests.Assign(rMHA_VISTA.GetListOfPreviousTests);

  //Write list of tests to string grid
  for itests := 1 to PatientSubSession.ListOfPreviousTests.Count do
  begin
    //filter out ASI's
    if not (Piece(PatientSubSession.ListOfPreviousTests[itests - 1], U, 3) =
      'ASI') then
    begin
      for icol := 0 to 2 do
        grdTestResults.Cells[icol, irow] :=
          Piece(PatientSubSession.ListOfPreviousTests[itests - 1], U, icol +
          2);
      inc(irow);
    end;
  end;
  //irow = 1 if there were no tests (other than the ASI)
  if irow = 1 then
  begin
    grdTestResults.Cells[0, 1] := '';
    grdTestResults.Cells[1, 1] := 'None';
    grdTestResults.RowCount := 2;
  end
  else
  begin
    grdTestResults.RowCount := irow;
    SortTests;
  end;

end;

procedure TfrmMain.DisplayPrevASI;
//******************************************************************************
// PURPOSE: Retrieve previous ASI information and write it to a string grid
//******************************************************************************
var
  irow: integer;
  //  tmpG12: string;
begin
  //Load test names and dates of previous tests
  PatientSubSession.ListOfPreviousASIs.Assign(rMHA_VISTA.GetListOfPreviousASIs);

  grdOldASI.RowCount := PatientSubSession.ListOfPreviousASIs.Count;

  //If no previous ASI's
  if PatientSubSession.ListOfPreviousASIs[1] = '0' then
  begin
    for irow := 0 to 5 do
      grdOldASI.Cells[irow, 1] := '';
    grdOldASI.Cells[0, 1] := 'None';
  end
  else
    //If there are previous ASI's
  begin

    for irow := 1 to PatientSubSession.ListOfPreviousASIs.Count - 1 do
    begin
      //insert '01/01/1900' for missing dates
      if (Piece(PatientSubSession.ListOfPreviousASIs[irow], U, 2) = '') then
        grdOldASI.Cells[0, irow] := '01/01/1900'
      else
        grdOldASI.Cells[0, irow] :=
          MixedCase(Piece(PatientSubSession.ListOfPreviousASIs[irow], U,
          2));
      //Date

//Don't use mixed case for ASI-MV
      if Piece(PatientSubSession.ListOfPreviousASIs[irow], U, 3) = 'ASI-MV' then
        grdOldASI.Cells[1, irow] :=
          Piece(PatientSubSession.ListOfPreviousASIs[irow], U, 3)
      else
        grdOldASI.Cells[1, irow] :=
          MixedCase(Piece(PatientSubSession.ListOfPreviousASIs[irow], U,
          3)); //Type

      grdOldASI.Cells[2, irow] :=
        MixedCase(Piece(PatientSubSession.ListOfPreviousASIs[irow], U,
        6)); //Interviewer

      //      tmpG12 :=
      //        MixedCase(Piece(PatientSubSession.ListOfPreviousASIs[irow], U,
      //        4)); //G-12
      //      if tmpG12 = 'Interview Completed' then
      //        tmpG12 := 'Not Refused, Terminated or Unable to Respond';
      //      grdOldASI.Cells[3, irow] := tmpG12;
      grdOldASI.Cells[3, irow] :=
        MixedCase(Piece(PatientSubSession.ListOfPreviousASIs[irow], U, 4));
      //G-12

  //Signed  NB: The broker returns a null if it is not signed
      if Piece(PatientSubSession.ListOfPreviousASIs[irow], U, 5) = 'YES' then
        grdOldASI.Cells[4, irow] := 'Yes'
      else
        grdOldASI.Cells[4, irow] := 'No';

      grdOldASI.Cells[5, irow] :=
        Piece(PatientSubSession.ListOfPreviousASIs[irow], U, 1); //IENS
    end;
  end;

  grdOldASI.SortSettings.Direction := sdDescending;
  grdOldASI.SortByColumn(0);

end;

procedure TfrmMain.mnuSelectPtClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Invoke patient selection dialog, check GAF reminder, test results
//******************************************************************************
begin
  //Toggle CPRS context for selecting a patient.
  RPCBrokerV.CreateContext('OR CPRS GUI CHART');

  { BEGIN CPRS Tools menu}
  if not UserSession.IsCPRSTool then
  begin
    { END CPRS Tools menu}

    (*CPRS code Begin*)
    SelectPatient(FALSE, Font.Size);
    (*CPRS code End*)

    if Patient.DFN = '' then
    begin
      Close;
      Exit;
    end;
    { BEGIN CPRS Tools menu}
  end
  else
  begin
    Patient.DFN := UserSession.CPRSPatientDFN;
    mnuSelectPt.Visible := false;
  end;
  { END CPRS Tools menu}

  PatientSubSession.ResetDateOfDeath;

  //Toggle MH context for remainder of application's life, unless another
  //patient is selected.
  RPCBrokerV.CreateContext('YS BROKER1');

  with Patient do
    btnPatient.Caption := ' Pt. I&nfo:  ' + Name + CRLF
      + ' ' + SSN + '   ' + FormatFMDateTime('mmm dd,yyyy', DOB) + ' (' +
      IntToStr(Age) + ')';

  mnuRefreshClick(Self);

end;

procedure TfrmMain.GAFReminder;
//******************************************************************************
// PURPOSE: Show reminder if no GAF in past 90 days
//******************************************************************************
var
  LastGAF: TDateTime;
begin

  //Set LastGaf to value > 90 days ago
  LastGaf := Now - 100;

  //Reset LastGaf if there is a previous GAF
  if grdGafResults.Cells[0, 1] <> 'None' then
    LastGaf := StrToDate(grdGafResults.Cells[0, 1]);

  //Calculate whether the last GAF was over 90 days ago
  if (DaysApart(LastGAF, Now) < 90)
    or PatientSubSession.PatientIsDead then
    GafNotDue
  else
  begin
    //Set the panels, labels, images and status bar appropriately if GAF due
    btnGAFDue.Enabled := True;
    mnuGAFDue.Visible := True;
    mnuGAFDuePU.Visible := True;
    btnGAFDue.Caption := 'GAF D&ue';
    StatusBarMsg(1, MixedCase(Piece(Patient.Name, ',', 2) + ' '
      + Piece(Patient.Name, ',', 1)) +
      ' has not had a GAF in over 90 days.');
  end;

end;

procedure TfrmMain.ASIReminder;
//******************************************************************************
// PURPOSE: Notify user if no ASI in past 150 days
//******************************************************************************
var
  LastASI: TDateTime;
  tmpDaysApart: integer;
begin

  //Case of no previous ASI's
  if grdOldASI.Cells[0, 1] = 'None' then
  begin
    StatusBarMsg(1, 'Does this patient need an ASI?');
    Exit;
  end;

  LastASI := StrToDate(grdOldASI.Cells[0, 1]);
  tmpDaysApart := DaysApart(LastASI, Now);
  if not PatientSubSession.PatientIsDead then
    StatusBarMsg(1, 'Last ASI was ' + IntToStr(tmpDaysApart) + ' days ago');

end;

procedure TfrmMain.GafNotDue;
//******************************************************************************
// PURPOSE: Set the panels, labels, images and status bar appropriately if GAF not due
//******************************************************************************
begin
  btnGAFDue.Enabled := False;
  mnuGAFDue.Visible := False;
  mnuGAFDuePU.Visible := False;
  btnGAFDue.Caption := 'GAF Not Due';
  StatusBarMsg(1, ' ');
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
//******************************************************************************
// PURPOSE:
//******************************************************************************
begin
  if FCreateProgress < FCP_FINISH then
    FTerminate := True;
  // unhook the timeout hooks
  ShutDownTimeOut;

  MHA_Registry.MainTop := Top;
  MHA_Registry.MainLeft := Left;
  MHA_Registry.MainHeight := Height;
  MHA_Registry.MainWidth := Width;
  MHA_Registry.UseDefaultWindow := mnuDefaultFormSizes.Checked;
  MHA_Registry.ShowAllHints := mnuShowHints.Checked;
  if MHA_Registry.MainTabOrder > 3 then // Save last tab used
    MHA_Registry.MainTabOrder := pgctrlMain.ActivePageIndex + 10;
  MHA_Registry.SaveRegistry;

  Application.ProcessMessages; // so everything finishes closing
  // if < FCP_FINISH we came here from inside FormCreate, so need to call terminate
  if FCreateProgress < FCP_FINISH then
    Application.Terminate;
end;

procedure TfrmMain.cbxOrderedByNeedData(Sender: TObject;
  const StartFrom: string; Direction, InsertAt: Integer);
//******************************************************************************
// PURPOSE: Gets list of staff for Ordered By combo box
//******************************************************************************
begin
  inherited;
  (Sender as TORComboBox).ForDataUse(SubSetOfPersons(StartFrom, Direction));
end;

procedure TfrmMain.cbxOrderedByChange(Sender: TObject);
//******************************************************************************
// PURPOSE: Update TestOrderer object, list of orderable tests, etc.
//******************************************************************************
begin

  //Clear the list of selected tests
  btnDeleteAllClick(Sender);

  // No "ordered-by" person chosen yet, so clear some controls.
  if cbxOrderedBy.Text = '' then
  begin
    StatusBarMsg(1, '');
    exit;
  end;

  TestOrderer.DUZ := cbxOrderedBy.ItemIEN;
  TestOrderer.Name := cbxOrderedBy.Text;

  //Toggle CPRS context for detecting user key.
  RPCBrokerV.CreateContext('OR CPRS GUI CHART');

  TestOrderer.HasYSPKey := personhaskey(TestOrderer.DUZ, 'YSP');
  //Toggle MH context.
  RPCBrokerV.CreateContext('YS BROKER1');

  //Assign orderable tests
  TestOrderer.OrderableTests.Assign(rMHA_Vista.GetOrderableTests);
  lstTestChoices.Items.Assign(TestOrderer.OrderableTests);

  //List available batteries
  lstTestBatteries.Clear;
  lstTestBatteries.Items.Assign(rMHA_VISTA.GetListOfBatteries);
  grpBattery.Visible := lstTestBatteries.Items.Count > 0;

  DisplayOrderingPriviledge;
  UpdateFullTestList;

end;

procedure TfrmMain.DisplayOrderingPriviledge;
//******************************************************************************
// PURPOSE: Display ordering priviledge on the statusbar
//******************************************************************************
var
  tmpMsg, tmpName: string;
begin
  tmpMsg := '  ';
  tmpName := TestOrderer.Name;
  tmpName := Piece(tmpName, ',', 2) + ' ' + Piece(tmpName, ',', 1);

  //Check whether the orderer has the YSP key
  if TestOrderer.HasYSPKey then
    tmpMsg := ' may order any test.'
  else
    tmpMsg := ' may order exempt tests.';

  //notify if session user is not the test orderer
  if not (TestOrderer.Name = MixedCase(User.Name)) then
    StatusBarMsg(0, '  ' + tmpName + ' will be notified of this testing.')
  else
    StatusBarMsg(0, ' ');

  StatusBarMsg(1, '  ' + tmpName + tmpMsg);
end;

procedure TfrmMain.UpdateFullTestList;
//******************************************************************************
// PURPOSE: Add the restartable tests to the main test list.
//******************************************************************************
var
  i: integer;
  tmpTest: string;
begin
  //add restartable tests to list of orderable tests
  for i := 1 to grdIncompleteTests.RowCount - 1 do
    if (grdIncompleteTests.Cells[3, i] = 'restartable') then
    begin
      tmpTest := grdIncompleteTests.Cells[1, i] + '*';
      if lstTestChoices.Items.IndexOf(tmpTest) = -1 then
        lstTestChoices.Items.Add(grdIncompleteTests.Cells[4, i] + '^' +
          tmpTest);
    end;
end;

procedure TfrmMain.SortTests;
//******************************************************************************
// PURPOSE: Sorts list of completed tests by date (default) or name
//******************************************************************************
begin
  if rgrpSortTests.ItemIndex = 1 then
  begin
    grdTestResults.SortSettings.Direction := sdAscending;
    grdTestResults.SortByColumn(1);
  end
  else
  begin
    grdTestResults.SortSettings.Direction := sdDescending;
    grdTestResults.SortByColumn(0);
  end;
end;

procedure TfrmMain.grdTestResultsClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Gets text report for selected test, graphs as appropriate
//******************************************************************************
var
  tmpName, YSText, tmpUser, rec: string;
  i: integer;
  MousePos: TPoint;
begin
  //Do this so you can return the mouse to its original position at the
  //end of this event
  MousePos := Mouse.CursorPos;

  StatusBarMsg(0, '  Retrieving test report...');

  memTestResults.Clear;
  tmpName := grdTestResults.Cells[1, grdTestResults.Row];

  //exit if there are no previous tests
  if (tmpName = 'None') or
    (tmpName = '') then
  begin
    chrtTests.Visible := False;
    memTestResults.Lines.Add('No test results available.');
    exit;
  end;

  //Exit if user does not have permission to see results of exempt tests
  if (not FHasYSP) and
    (grdTestResults.Cells[2, grdTestResults.Row] = 'P') then
  begin
    chrtTests.Visible := False;
    Beep;
    tmpUser := MixedCase(Piece(User.Name, ',', 2) + ' ' + Piece(User.Name,
      ',',
      1));
    memTestResults.Lines.Add(tmpUser + ' does not have permission to view' +
      CRLF
      + 'the results of the ' + tmpName + '.');
    DisablePrimaryButtonsAndMenus;
    exit;
  end;

  CheckForMultiScale;

  //Find the IENS of the selected test name
  MHA_DataModule.FMFindOne1.RPCBroker := RPCBrokerV;
  MHA_DataModule.FMGets1.IENS := '';
  MHA_DataModule.FMFindOne1.Value := tmpName;
  MHA_DataModule.FMFindOne1.FileNumber := '601';
  rec := MHA_DataModule.FMFindOne1.GetIEN;

  if rec = '' then
  begin
    MHA_DataModule.FMFindOne1.DisplayErrors;
    exit;
  end
  else if StrToInt(rec) > 0 then
    //Set YSText = FMDate of the test + ',' + test iens
    YSText :=
      FloatToStr(DateTimeToFMDateTime(StrToDate(grdTestResults.Cells[0,
      grdTestResults.Row]))) +
      ',' + rec
  else
  begin
    memTestResults.Lines.Add('No records matched.');
    exit;
  end;

  //insert text-based results in memo box
  PatientSubSession.TestReport.Assign(rMHA_Vista.GetTestReport(
    'YTRP INSTRUMENT REPORT', Patient.DFN, YStext));

  if PatientSubSession.TestReport.Count > 0 then
    for i := 0 to PatientSubSession.TestReport.Count - 1 do
      memTestResults.Lines.Add(PatientSubSession.TestReport[i]);

  memTestResults.SelStart := 0;
  mnuReports.Enabled := not (grdTestResults.Cells[1, 1] = 'None');
  mnuGraphs.Enabled := chrtTests.Visible;
  mnuReportsPU.Enabled := not (grdTestResults.Cells[1, 1] = 'None');
  mnuGraphsPU.Enabled := chrtTests.Visible;
  btn2.Enabled := not (grdTestResults.Cells[1, 1] = 'None');
  mnuEnlargeReport.Enabled := not (grdTestResults.Cells[1, 1] = 'None');
  btn3.Enabled := not (grdTestResults.Cells[1, 1] = 'None');
  mnuAppendComments.Enabled := not (grdTestResults.Cells[1, 1] = 'None');

  //Workaround, to remove control characters from the test report(s)
  memTestResults.Lines.Delete(0);
  memTestResults.Refresh;

  StatusBarMsg(0, '');
  //return the mouse to its original position
  Mouse.CursorPos := MousePos;
  Application.ProcessMessages;

end;

procedure TfrmMain.CheckForMultiScale;
//******************************************************************************
// PURPOSE: Calls graph procedure for single-scale tests,
//          enables panel that creates TestGraph for multi-scale tests
//******************************************************************************
const
  Multiscale =
    'BPRS BSI18 BUSS MBMD MCMI2 MCMI3 MMP2S MMPI2 NEOPI PAI SF36 STAI';

var
  tmpName {, Multiscale}: string;
begin

  if (grdTestResults.Cells[1, grdTestResults.Row] = 'P')
    and not FHasYSP then
    Exit;

  tmpName := grdTestResults.Cells[1, grdTestResults.Row];
  if (pos(tmpName, Multiscale) = 0) or (tmpName = 'MMPI') then
  begin
    btn1.Enabled := False;
    mnuMultiScaleGraphs.Enabled := False;
    GraphTestData;
  end
  else
  begin
    //Enable "Miltiscale Graphs" button
    chrtTests.Visible := False;
    btn1.Enabled := True;
    mnuMultiScaleGraphs.Enabled := True;
  end;

end;

procedure TfrmMain.MCMI2;
begin
  //checks for either MCMI2 or MCMI3
  if (lstTestsChosen.Items.IndexOf('MCMI2') = -1)
    and (lstTestsChosen.Items.IndexOf('MCMI3') = -1) then
    exit;

  frmMCMI2 := TfrmMCMI2.Create(Self);
  try
    frmMCMI2.ShowModal;
  finally
    frmMCMI2.Free;
  end;

end;

procedure TfrmMain.GraphTestData;
//******************************************************************************
// PURPOSE: Graphs scores of all instances of a single-scale test
//******************************************************************************
var
  i, NumOfTests: Integer;
  tmpName: string;
begin
  tmpName := grdTestResults.Cells[1, grdTestResults.Row];

  NumOfTests := 0; // Number of same-type tests in the list

  //Count the number of same-type tests in the list
  for i := 1 to grdTestResults.RowCount - 1 do
    if grdTestResults.cells[1, i] = tmpName then
      inc(NumOfTests);

  //If only one test of this type, don't display graph
  if NumOfTests < 2 then
  begin
    chrtTests.Visible := False;
    exit;
  end;

  //Load scale scores of previous tests
  PatientSubSession.ScaleScores.Assign(rMHA_VISTA.GetScaleScores(tmpName));

  //bail out if an integer scale score is not returned
  if (PatientSubSession.ScaleScores.Count < 2) or
    (Piece(PatientSubSession.ScaleScores[1], U, 5) = '') then
  begin
    chrtTests.Visible := False;
    exit;
  end;

  with chrtTests do
  begin
    Visible := True;
    Series1.Clear;
    Title.Text.Clear;
    Title.Text.Text := tmpName;
    LeftAxis.Title.Caption := 'Score';

    for i := PatientSubSession.ScaleScores.Count - 1 downto 1 do
    begin
      Series1.AddXY(StrToDate(Piece(PatientSubSession.ScaleScores[i], U,
        2)),
        StrToInt(Piece(PatientSubSession.ScaleScores[i], U, 5)),
        Piece(PatientSubSession.ScaleScores[i], U, 2), clred);
    end;
  end; //with chrtTests
end;

procedure TfrmMain.InitgrdOldASI;
//******************************************************************************
// PURPOSE: Set column widths, headings for string grid that lists previous ASI's
//******************************************************************************
var
  tmpWidth: integer;
begin
  with grdOldASI do
  begin
    ColCount := 6;
    ColWidths[0] := 80;
    ColWidths[1] := 70;
    ColWidths[2] := 150;
    ColWidths[4] := 70;
    ColWidths[5] := 100;

    tmpWidth := Width - (ColWidths[0] + ColWidths[1] + ColWidths[2]
      + ColWidths[4]);
    if tmpWidth < 150 then
      tmpWidth := 150;
    ColWidths[3] := tmpWidth;

    Cells[0, 0] := 'Date';
    Cells[1, 0] := 'Type';
    Cells[2, 0] := 'Interviewer';
    Cells[3, 0] := 'G-12 Special';
    Cells[4, 0] := 'Signed';
  end;

  InitASIEditBtn;

end;

procedure TfrmMain.InitASIEditBtn;
begin
  with grdOldASI do
  begin
    if Cells[4, Row] = 'No' then
      btnEditASI.Enabled := true
    else
      btnEditASI.Enabled := false;

    if Cells[1, Row] = 'ASI-MV' then
      btnEditASI.Caption := 'Sign ASI-MV'
    else
      btnEditASI.Caption := '&Edit ASI';
  end; //with grdOldASI
end;

procedure TfrmMain.pgctrlMainChange(Sender: TObject);
//******************************************************************************
// PURPOSE: Initiate tab-specific actions when user goes to test results,
//          test order, ASI, or GAF tab
//******************************************************************************
begin
  SetupTabs(sender);
end;

procedure TfrmMain.DisablePrimaryButtonsAndMenus;
begin
  btn1.Enabled := False;
  btn2.Enabled := False;
  btn3.Enabled := False;
  mnuAppendComments.Visible := False;
  mnuEnlargeReport.Visible := False;
  mnuGraphs.Enabled := False;
  mnuGraphsPU.Enabled := False;
  mnuReports.Enabled := False;
  mnuReportsPU.Enabled := False;
  mnuBtn1PU.Visible := False;
  mnuBtn2PU.Visible := False;
  mnuBtn3PU.Visible := False;
end;

//procedure TfrmMain.SetSecondaryPopUpMenus;
//begin
//  mnuBtn1PU.Caption := btn1.Caption;
//  mnuBtn1PU.Visible := btn1.Enabled;
//  mnuBtn2PU.Caption := btn2.Caption;
//  mnuBtn2PU.Visible := btn2.Enabled;
//  mnuBtn3PU.Caption := btn3.Caption;
//  mnuBtn3PU.Visible := btn3.Enabled;
//end;

procedure TfrmMain.ClearSecondaryButtonsAndMenus;
begin
  btn1.Caption := ' ';
  btn2.Caption := ' ';
  btn3.Caption := ' ';
  btn1.Hint := '';
  btn2.Hint := '';
  btn3.Hint := '';

  mnuClerkEntry.Visible := False;
  mnuDeleteAllTests.Visible := False;
  mnuDeleteAllTestsPU.Visible := False;
  mnuDeleteOneTest.Visible := False;
  mnuDeleteOneTestPU.Visible := False;
  mnuDomainScores.Visible := False;
  mnuEditRating.Visible := False;
  mnuItemTrends.Visible := False;
  mnuMultiScaleGraphs.Visible := False;
  mnuNewASI.Visible := False;
  mnuPatientEntry.Visible := False;
  mnuPreviousRatings.Visible := False;
  mnuSaveRating.Visible := False;
  mnuSelectAvailableTest.Visible := False;
  mnuSelectAvailableTestPU.Visible := False;
  mnuSelectBattery.Visible := False;
  mnuStaffEntry.Visible := False;
  mnuTestInfo.Visible := False;
  mnuTestInfoPU.Visible := False;
  //  mnuTestResults.Enabled := False;
  //  mnuOrderTests.Enabled := False;
  //  mnuASI.Enabled := False;
  //  mnuGAF.Enabled := False;

end;

procedure TfrmMain.InitGrdTestResults;
begin

  //Set column widths and headers for test results string grid
  with grdTestResults do
  begin
    ColWidths[0] := 75;
    ColWidths[1] := 80;
    ColWidths[2] := 0;
    Cells[0, 0] := 'Date';
    Cells[1, 0] := 'Test';
    Row := 1;
  end;

end;

procedure TfrmMain.SetupTabs(Sender: TObject);

  procedure ShowReportsAndGraphs(Show: BOOLEAN);
  begin
    mnuReports.Visible := Show;
    mnuReportsPU.Visible := Show;
    mnuGraphs.Visible := Show;
    mnuGraphsPU.Visible := Show;
  end;

begin

  //Disable/clear all the buttons and menus
  DisablePrimaryButtonsAndMenus;
  ClearSecondaryButtonsAndMenus;

  StatusBarMsg(1, '');

  //tab-specific actions
  case pgctrlMain.ActivePageIndex of
    0: //Test results tab
      begin
        mnuMultiScaleGraphs.Visible := True;
        mnuEnlargeReport.Visible := True;
        mnuAppendComments.Visible := True;
        ShowReportsAndGraphs(True);

        mnuTestInfo.Visible := True;
        mnuTestInfoPU.Visible := True;

        pgctrlMain.activepage := tbshtTestResults;
        btn1.Caption := '&Multi-Scale Graphs';
        btn2.Caption := '&Enlarge Report';
        btn1.Hint := 'Display results of MMPI2 and other multi-scale tests';
        btn2.Hint := 'See full-screen view of test report';
        btn3.Caption := 'A&ppend Comments';
        btn3.Hint := 'Add free text comments to test results';

        //Notify user
        StatusBarMsg(0, '  Retrieving test results...');

        if FFirstTestResults then
        begin
          InitgrdTestResults;
          DisplayPrevTests(Sender);
          //Set FFirstTestResults := False later to avoid having to load
          //test report right now
        end;

        DisplayViewingPriviledge;

        //Don't enable buttons and menus that would give user without YSP
        //access to test results
        if (not FHasYSP) and
          (grdTestResults.Cells[2, grdTestResults.Row] = 'P') then
        begin
          grdTestResultsClick(Sender);
          Exit;
        end; //if (not FHasYSP)...

        CheckForMultiScale;

        mnuReports.Enabled := not (grdTestResults.Cells[1, 1] = 'None');
        mnuGraphs.Enabled := chrtTests.Visible;
        mnuReportsPU.Enabled := not (grdTestResults.Cells[1, 1] = 'None');
        mnuGraphsPU.Enabled := chrtTests.Visible;
        btn2.Enabled := not (grdTestResults.Cells[1, 1] = 'None');
        mnuEnlargeReport.Enabled := not (grdTestResults.Cells[1, 1] =
          'None');
        btn3.Enabled := not (grdTestResults.Cells[1, 1] = 'None');
        mnuAppendComments.Enabled := not (grdTestResults.Cells[1, 1] =
          'None');

        //After everything else is done, load the test report if this is the
        //first visit to this tab since a new patient was selected
        if FFirstTestResults then
          grdTestResultsClick(Sender);

        FFirstTestResults := False;

      end; //Test results tab

    1: //Test order tab
      begin
        //Check to see if pt is deceased, then check to see if data entry OK
        with PatientSubSession do
        begin
          if PatientIsDead then
            if not DeceasedPatientDataEntryOK('test') then
            begin
              pgctrlMain.ActivePageIndex := 0;
              SetUpTabs(Self);
              exit;
            end;
        end; //with Patient SubSession

        mnuStaffEntry.Visible := True;
        mnuClerkEntry.Visible := True;
        mnuPatientEntry.Visible := True;
        mnuTestInfo.Visible := True;
        mnuTestInfoPU.Visible := True;
        ShowReportsAndGraphs(False);

        //Change "faux button" labels
        btn1.Caption := '&Staff Entry';
        btn2.Caption := 'Cler&k Entry';
        btn3.Caption := '&Patient Entry';
        btn1.Hint := 'Questions and choices visible.  '
          + 'Application does not terminate when data entry is complete.';
        btn2.Hint := 'Questions and choices not visible.  '
          + 'Application does not terminate when data entry is complete.';
        btn3.Hint := 'Use for on-line testing of the patient.  '
          + 'Application terminates when testing is completed.';

        pgctrlMain.activepage := tbshtOrderTests;
        SetTestSelectionButtons;
        if FFirstOrderTab then
        begin

          btnDeleteAllClick(Self);
          lstTestChoices.Clear;
          grdIncompleteTests.Clear;

          //Notify user
          StatusBarMsg(0, '  Retrieving test ordering information...');

          cbxOrderedBy.InitLongList(User.Name);
          cbxOrderedBy.SelectByIEN(User.DUZ);

          cbxOrderedByChange(Sender);

          DisplayIncompleteTests;

          FFirstOrderTab := False;

        end; //if FFirstOrderTab then

      end; //Test order tab

    2: //ASI Results Tab
      begin
        pgctrlMain.activepage := tbshtASI;

        mnuNewASI.Visible := True;
        mnuDomainScores.Visible := True;
        mnuItemTrends.Visible := True;
        ShowReportsAndGraphs(True);

        //Notify user
        StatusBarMsg(0, '  Retrieving ASI information...');

        btn1.Caption := 'Ne&w ASI';
        btn2.Caption := 'Domain &Scores';
        btn3.Caption := '&Item Trends';
        mnuItemTrends.Caption := '&Item Trends';
        btn1.Enabled := True;
        mnuNewASI.Enabled := True;
        btn2.Enabled := False;
        mnuDomainScores.Enabled := False;
        btn3.Enabled := False;
        mnuItemTrends.Enabled := False;
        pnlOldASIOuter.Visible := True;
        pnlASITrends.Visible := False;
        mnuReports.Enabled := True;
        mnuReportsPU.Enabled := True;
        btn1.Hint := 'Enter data for a new ASI';
        btn2.Hint := 'Graphs and tables of evaluation factor scores '
          + 'and problem severity ratings across interviews';
        btn3.Hint :=
          'Graphs and tables of items responses across interviews';

        if FFirstASITab then
        begin
          InitgrdAsiTrends;
          InitgrdOldAsi;
          DisplayPrevASI;
          {This procedure is used in both conditions of the "if" statement on
          purpose to control when the buttons are set relative to retrieving
          the interview report, which is slow}
          SetASIGraphButtons;
          ASIReminder;
          grdOldASIClick(Self);
          FFirstASITab := False;
        end
        else
          SetASIGraphButtons;

        StatusBarMsg(0, '  ');

      end; //ASI Results Tab

    3: //GAF tab
      begin
        lblGAFCopyright.Caption := '  Reprinted with permission from the '
          + 'Diagnostic and Statistical Manual of Mental Disorders, Fourth Edition.'
          + CRLF + '  Copyright 1994 American Psychiatric Association.';

        mnuPreviousRatings.Visible := True;
        mnuSaveRating.Visible := True;
        mnuEditRating.Visible := True;
        ShowReportsAndGraphs(True);

        btn1.Caption := '&Previous Ratings';
        mnuPreviousRatings.Caption := '&Previous Ratings';
        btn2.Caption := '&Save Rating';
        btn3.Caption := '&Edit Rating';
        pnlOldGAF.Visible := False;
        pnlGAFCriterion.Visible := False;
        pnlAllGAFCriteria.Visible := True;
        btn1.Enabled := True;
        mnuPreviousRatings.Enabled := True;

        //Don't allow rating date to be later than date of death if patient dead
        if PatientSubSession.PatientIsDead then
        begin
          //Set MaxDate first so it is > than DOD
          dtpkrEval.MaxDate := Date;
          dtpkrEval.Date := PatientSubSession.DOD;
          dtpkrEval.MaxDate := PatientSubSession.DOD;
        end
        else
        begin
          //Set MaxDate first so it is > than Date
          //Set MaxDate to tomorrow so setting dtpkr.Date to Date will
          //change the value, then reset MaxDate to Date
          dtpkrEval.MaxDate := Date + 1;
          dtpkrEval.Date := Date;
          dtpkrEval.MaxDate := Date;
        end;

        btn1.Hint :=
          'Switch between GAF criteria and list of previous ratings';
        btn2.Hint := 'Save the GAF rating';
        btn3.Hint := 'Edit, delete, or mark as entered in error';

        if FFirstGAFTab then
        begin
          pgctrlMain.activepage := tbshtGAF;
          //Notify user
          StatusBarMsg(0, '  Retrieving GAF information...');

          spnedtGAF.Value := 1;
          InitgrdGAFResults;
          ResizeGafCriteria;
          LoadGAFCriteria;
          DisplayPrevGAFs;
          grdGAFResults.SortSettings.Direction := sdDescending;
          grdGAFResults.SortByColumn(0);
          GraphGafData;
          lblGAFSingleCriterion.Caption := 'GAF 1 Criteria: '
            + grdGAFCriteria.Cells[1, 1];
          FFirstGAFTab := False;
        end;

        StatusBarMsg(0, ' ');

      end; //GAF tab

  end; //case

  //refresh all controls
  Application.ProcessMessages;

end;

function TfrmMain.ASIIsCompleted(RowNum: integer): BOOLEAN;
begin
  result := (grdOldASI.Cells[4, RowNum] = 'Yes') and
    (grdOldASI.Cells[3, RowNum] = G12OK);
end;

procedure TfrmMain.SetASIGraphButtons;
//******************************************************************************
// PURPOSE: Enable ASI trends and domain scores buttons
//******************************************************************************
var
  NumSigned, irow: integer;
begin

  //count the number of signed, complete ASI's
  NumSigned := 0;
  for irow := 1 to grdOldASI.RowCount - 1 do
    if ASIIsCompleted(irow) then
      NumSigned := NumSigned + 1;

  //if there is at least 1 signed ASI, enable Domain Scores button
  if NumSigned > 0 then
  begin
    btn2.Enabled := True;
    mnuDomainScores.Enabled := True;
  end;

  //if there are at least 2 signed ASIs, then enable Item Trends button
  if NumSigned > 1 then
  begin
    btn3.Enabled := True;
    mnuItemTrends.Enabled := True;
  end;

end;

procedure TfrmMain.InitgrdGAFResults;
//******************************************************************************
// PURPOSE: Set column widths and headings for GAF results string grid
//******************************************************************************
begin
  //init string grid
  with grdGafResults do
  begin
    ColCount := 5;
    ColWidths[0] := 75; //Date
    ColWidths[1] := 40; //Rating
    ColWidths[2] := 200; //Rater
    ColWidths[3] := 0; //IENS
    ColWidths[4] := 0; //ERROR comment
    Cells[0, 0] := 'Date';
    Cells[1, 0] := 'GAF';
    Cells[2, 0] := 'Clinician';
  end;
end;

procedure TfrmMain.ResizeGAFCriteria;
begin
  with grdGafCriteria do
  begin
    ColWidths[0] := 40;
    ColWidths[1] := Width - 60;
    ;
  end;

end;

procedure TfrmMain.DisplayPrevGAFs;
//******************************************************************************
// PURPOSE: Retrieve previous GAF ratings and write to string grid
//******************************************************************************
var
  irow: integer;
begin

  //retrieve previous GAF ratings
  PatientSubSession.ListOfPreviousGAFs.Assign(rMHA_VISTA.GetListOfPreviousGAFs);

  //if there are previous ratings, write them to string grid
  if PatientSubSession.ListOfPreviousGAFs.Count > 0 then
  begin
    grdGafResults.RowCount := PatientSubSession.ListOfPreviousGAFs.Count +
      1;
    for irow := 0 to PatientSubSession.ListOfPreviousGAFs.Count - 1 do
      with grdGafResults do
      begin
        // '3000411.095^04/11/2000@09:50^GAF^GAF^53^IENS^Cannon,DALE S^ERROR: entered in error blah blah'
        Cells[0, irow + 1] :=
          Piece(Piece(PatientSubSession.ListOfPreviousGAFs[irow],
          U, 2), '@', 1); //date
        Cells[1, irow + 1] :=
          Piece(PatientSubSession.ListOfPreviousGAFs[irow],
          U, 5); //score
        Cells[2, irow + 1] :=
          Piece(PatientSubSession.ListOfPreviousGAFs[irow],
          U, 7); //rater
        Cells[3, irow + 1] :=
          Piece(PatientSubSession.ListOfPreviousGAFs[irow],
          U, 6); //IENS
        Cells[4, irow + 1] :=
          UpperCase(Piece(Piece(PatientSubSession.ListOfPreviousGAFs[irow],
          U, 8), ':', 1)); //comment will = ERROR if entered in error
      end;
  end

  else //if there are no previous GAF ratings
  begin
    with grdGafResults do
    begin
      RowCount := 2;
      Cells[0, 1] := 'None';
      Cells[1, 1] := '';
      Cells[2, 1] := '';
    end;
  end;
  grdGAFResults.TopRow := 1;
  grdGAFResultsClick(Self);
end;

procedure TfrmMain.btnSelectTestClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Order tests to be administered, check for conflicts with ordered
//          incomplete tests
//******************************************************************************
var
  Index, i, DeleteIndex: Integer;
  tmpSelectedTest, tmpOrderedTest, tmpTest: string;
  TestMatch: boolean;
begin

  //identify index number of selected test
  Index := lstTestChoices.ItemIndex;
  //exit if the click was not on an item
  if Index < 0 then
  begin
    SetTestSelectionButtons;
    exit;
  end;

  //Get the test name
  tmpSelectedTest := Piece(lstTestChoices.Items[Index], U, 2);

  //drop the '*' if it is a restartable test
  if pos('*', tmpSelectedTest) > 0 then
    tmpSelectedTest := copy(tmpSelectedTest, 1, Length(tmpSelectedTest) -
      1);

  //see if the test has already been ordered, which will happen only if there
  //is a restartable instance of the test
  DeleteIndex := 0;
  TestMatch := False;
  for i := 0 to lstTestsChosen.Items.Count - 1 do
  begin
    tmpOrderedTest := Piece(lstTestsChosen.Items[i], U, 2);
    //check for restartable test, drop the '*' if it is
    if pos('*', tmpOrderedTest) > 0 then
      tmpOrderedTest := copy(tmpOrderedTest, 1, Length(tmpOrderedTest) - 1);

    //Identify the match
    if tmpSelectedTest = tmpOrderedTest then
    begin
      DeleteIndex := i;
      tmpTest := lstTestsChosen.Items[i];
      TestMatch := True;
      Break;
    end;
  end;

  //if a restartable test has already been ordered
  if TestMatch and (pos('*', lstTestsChosen.Items[DeleteIndex]) > 0) then
    if MsgDlg('You already have asked to restart an incomplete '
      + tmpOrderedTest + '.' + CRLF + '' + CRLF
      + 'Are you sure that you want to administer a new ' + tmpOrderedTest
      + ' instead?', DlgCaption, mtConfirmation, [mbYes, mbNo], 0) = mrNo then
      Exit;

  //if a new test has already been ordered
  if TestMatch and (pos('*', lstTestsChosen.Items[DeleteIndex]) = 0) then
    if MsgDlg('You already have asked to administer a new '
      + tmpOrderedTest + '.' + CRLF + '' + CRLF
      + 'Are you sure that you want to restart an incomplete '
      + tmpOrderedTest + ' instead?', DlgCaption, mtConfirmation, [mbYes,
      mbNo],
        0) = mrNo then
      exit;

  //Delete the unwanted instance of the test already ordered
  if TestMatch then
    lstTestsChosen.Items.Delete(DeleteIndex);

  //add selected test to ordered tests, delete it from choices
  lstTestsChosen.Items.Add(lstTestChoices.Items[Index]);
  lstTestChoices.Items.Delete(Index);

  //in case of duplicates, add non-selected test back to list of choices
  if TestMatch then
    lstTestChoices.Items.Add(tmpTest);

  SetTestSelectionButtons;

end;

procedure TfrmMain.SetTestSelectionButtons;
//******************************************************************************
// PURPOSE: Enable/Disable test selection buttons and test administration panels
//          depending on # tests selected
//******************************************************************************
var
  DstEmpty: Boolean;
begin
  DstEmpty := lstTestsChosen.Items.Count = 0;
  btnSelectTest.Enabled := not lstTestChoices.ItemIndex < 0;
  btnDeleteTest.Enabled := not lstTestsChosen.ItemIndex < 0;
  btnDeleteAll.Enabled := not DstEmpty;
  btnBattery.Enabled := not lstTestBatteries.ItemIndex < 0;
  btn1.Enabled := not DstEmpty;
  mnuStaffEntry.Enabled := not DstEmpty;
  btn2.Enabled := not DstEmpty;
  mnuClerkEntry.Enabled := not DstEmpty;
  btn3.Enabled := not DstEmpty;
  mnuPatientEntry.Enabled := (not DstEmpty);
  mnuSelectAvailableTest.Visible := btnSelectTest.Enabled;
  mnuSelectAvailableTestPU.Visible := btnSelectTest.Enabled;
  mnuSelectBattery.Visible := btnBattery.Enabled;
  mnuDeleteOneTest.Visible := btnDeleteTest.Enabled;
  mnuDeleteOneTestPU.Visible := btnDeleteTest.Enabled;
  mnuDeleteAllTests.Visible := btnDeleteAll.Enabled;
  mnuDeleteAllTestsPU.Visible := btnDeleteAll.Enabled;

  if (LMDSysInfo1.Platform <> 'Windows NT') or not FSecureDesktopAvailable then
  begin
    mnuPatientEntry.Enabled := False;
    btn3.Enabled := False;
  end;

end;

procedure TfrmMain.btnDeleteTestClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Delete selected test from list of ordered tests
//******************************************************************************
var
  Index: Integer;
begin
  Index := lstTestsChosen.ItemIndex;
  if Index < 0 then
    exit;
  lstTestChoices.Items.Add(lstTestsChosen.Items[Index]);
  lstTestsChosen.Items.Delete(Index);
  SetTestSelectionButtons;
end;

procedure TfrmMain.btnDeleteAllClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Deleted all ordered tests
//******************************************************************************
var
  Index: Integer;
begin
  for Index := lstTestsChosen.Items.Count - 1 downto 0 do
  begin
    lstTestChoices.Items.Add(lstTestsChosen.Items[Index]);
    lstTestsChosen.Items.Delete(Index);
  end;
  SetTestSelectionButtons;

end;

procedure TfrmMain.lstTestsChosenDragDrop(Sender, Source: TObject; X,
  Y: Integer);
//******************************************************************************
// PURPOSE: Reorder the sequence of ordered tests using the mouse
//******************************************************************************
var
  CurIndex, NewIndex: integer;
begin
  CurIndex := lstTestsChosen.ItemIndex;
  NewIndex := lstTestsChosen.ItemAtPos(Point(X, Y), True);
  if NewIndex = -1 then
    NewIndex := lstTestsChosen.Items.Count - 1;
  with Source as TListBox do
  begin
    lstTestsChosen.Items.Move(CurIndex, NewIndex);
  end;
end;

procedure TfrmMain.lstTestsChosenDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
//******************************************************************************
// PURPOSE: Verify that the item being dragged over the listbox is from a listbox
//******************************************************************************
begin
  if Source is TListBox then
    Accept := True;
end;

procedure TfrmMain.lstTestsChosenMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
//******************************************************************************
// PURPOSE: Begin drag
//******************************************************************************
begin
  if Button = mbLeft then
  begin
    with Sender as TListBox do
    begin
      if ItemAtPos(Point(X, Y), True) >= 0 then
        BeginDrag(False);
    end;
  end;
end;

procedure TfrmMain.LoadGAFCriteria;
//******************************************************************************
// PURPOSE: Write GAF rating criteria in string grid
//******************************************************************************
begin
  with grdGAFCriteria do
  begin
    Cells[0, 0] := 'Range';
    Cells[0, 1] := '1-10';
    Cells[0, 2] := '11-20';
    Cells[0, 3] := '21-30';
    Cells[0, 4] := '31-40';
    Cells[0, 5] := '41-50';
    Cells[0, 6] := '51-60';
    Cells[0, 7] := '61-70';
    Cells[0, 8] := '71-80';
    Cells[0, 9] := '81-90';
    Cells[0, 10] := '91-100';

    Cells[1, 0] := 'Criteria';

    Cells[1, 1] := 'Persistent danger of severely hurting self or others '
      + '(e.g., recurrent violence) OR persistent inability to maintain minimal personal '
      + 'hygiene OR serious suicidal act with clear expectation of death.';

    Cells[1, 2] := 'Some danger of hurting self or others (e.g., suicide '
      + 'attempts without clear expectation of death; frequently violent; OR '
      + 'occasionally fails to maintain minimal personal hygiene (e.g., smears feces) '
      + 'OR gross impairment in communication (e.g., largely incoherent or mute).';

    Cells[1, 3] :=
      'Behavior is considerably influenced by delusions or hallucinations '
      + 'OR serious impairment in communication or judgment (e.g., sometime incoherent, '
      + 'acts grossly inappropriately, suicidal preoccupation) OR inability to function '
      + 'in almost all areas (e.g., stays in bed all day; no job, home or friends).';

    Cells[1, 4] :=
      'Some impairment in reality testing or communication (e.g., '
      + 'speech is at times illogical, obscure, or irrelevant) OR major impairment '
      + 'in several areas, such as work or school, family relations, judgment, thinking, or '
      + 'mood (e.g., depressed man avoids friends, neglects family, and is unable '
      + 'to work; child frequently beats up younger children, is defiant at home '
      + 'and is failing at school).';

    Cells[1, 5] :=
      'Serious symptoms (e.g., suicidal ideation, severe obsessional '
      + 'rituals, frequent shoplifting) OR any serious impairment in social, occupational, '
      + 'or school functioning (e.g., no friends, unable to keep a job).';

    Cells[1, 6] :=
      'Moderate symptoms (e.g., flat affect and circumstantial speech, '
      + 'occasional panic attacks) OR moderate difficulty in social, occupational, or '
      + 'school functioning (e.g., few friends, conflicts with peers or co-workers).';

    Cells[1, 7] :=
      'Some mild symptoms (e.g., depressed mood and mild insomnia) '
      + 'OR some difficulty in social, occupational or school functioning (e.g., '
      + 'occasional truancy, or theft within the household), but generally functioning '
      + 'pretty well, has some meaningful interpersonal relationships.';

    Cells[1, 8] :=
      'If symptoms are present, they are transient and expectable '
      + 'reactions to psychosocial stressors (e.g., difficulty concentrating after family '
      + 'argument); no more than slight impairment in social, occupational, or school '
      + 'functioning (e.g., temporarily falling behind in schoolwork).';

    Cells[1, 9] :=
      'Absent or minimal symptoms (e.g., mild anxiety before an exam), '
      + 'good functioning in all areas, interested and involved in a wide range of activities, '
      + 'socially effective, generally satisfied with life, no more than everyday problems '
      + 'or concerns (e.g., an occasional argument with family members).';

    Cells[1, 10] := 'Superior functioning in a wide range of activities, '
      + 'life' + '''' +
      's problems never seem to get out of hand, is sought out '
      + 'by others because of his or her many positive qualitites.  No symptoms.';

  end;

end;

procedure TfrmMain.spnedtGAFChange(Sender: TObject);
//******************************************************************************
// PURPOSE: When the GAF rating is changed, keep it in sync with criteria
//******************************************************************************
var
  tmpRow: integer;
begin
  //Disable save "button" until a valid rating is entered
  btn2.Enabled := False;
  mnuSaveRating.Enabled := False;

  //Correct for garbage keyboard entries
  with spnedtGAF do
  begin
    if pos('0', Text) = 1 then
      Text := copy(Text, 2, Length(Text) - 1);
    if Text = '' then
      exit;
    if Value > MaxValue then
      Value := MaxValue;
    if Value < MinValue then
      Value := MinValue;
  end;

  //Enable save "button"--if you got this far, it's a valid rating
  btn2.Enabled := True;
  mnuSaveRating.Enabled := True;

  //Reset selected row of all criteria string grid
  FspnGAFChange := True;
  tmpRow := ((spnedtGAF.Value - 1) div 10) + 1;
  grdGAFCriteria.Row := tmpRow;
  FspnGAFChange := False;

  //Reset text of single criterion static text
  lblGAFSingleCriterion.Caption := 'GAF ' + spnedtGAF.Text + ' Criteria: '
    + grdGAFCriteria.Cells[1, tmpRow];

end;

procedure TfrmMain.grdGAFCriteriaClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Reset GAF rating when criteria are clicked
//******************************************************************************
var
  LastDigit: integer;
begin
  //compute the last digit of the rating
  //otherwise, entering a value via keyboard to spnGAF gets stepped on
  //by this event
  if FspnGAFChange then
    LastDigit := spnedtGAF.Value mod 10
  else
    LastDigit := 5;

  if LastDigit = 0 then
    LastDigit := 10;

  //reset the rating
  spnedtGAF.Value := ((grdGAFCriteria.Row - 1) * 10) + LastDigit;
end;

procedure TfrmMain.GraphGAFData;
//******************************************************************************
// PURPOSE: Graph GAF ratings, if there are any
//******************************************************************************
var
  irow, NumNoErrors: integer;
begin
  //Note: data source for the graph is the string grid, which has already
  //      been loaded

  chrtGAF.Visible := True;

  NumNoErrors := 0;

  for irow := 1 to grdGAFResults.RowCount - 1 do
    if not (grdGAFResults.Cells[4, irow] = 'ERROR') then
      NumNoErrors := NumNoErrors + 1;

  if NumNoErrors < 2 then
  begin
    chrtGAF.Visible := False;
    exit;
  end; //if NumNoErrors < 2

  with chrtGAF do
  begin
    Series2.Clear;

    for irow := grdGafResults.RowCount - 1 downto 1 do
    begin
      if (grdGAFResults.Cells[4, irow] = 'ERROR') then
        continue;

      Series2.AddXy(StrToDate(grdGafResults.Cells[0, irow]),
        StrToInt(grdGafResults.Cells[1, irow]),
        grdGafResults.Cells[0, irow], clRed);
    end;
  end;

end;

procedure TfrmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
//******************************************************************************
// PURPOSE: Allows user to exit by pressing escape key
//******************************************************************************
begin

  if Key = vk_Escape then
    if
      (MsgDlg('You pressed the Escape key.  Are you sure you want to terminate the '
      + 'program?', DlgCaption, mtWarning, [mbYes, mbNo], 0)) = mrYes then
      Close;

  if (Key = vk_F1) and ((pgctrlMain.ActivePage = tbshtOrderTests) or
    (pgctrlMain.ActivePage = tbshtTestResults)) then
    mnuTestInfoClick(Self);
end;

procedure TfrmMain.rgrpSortTestsClick(Sender: TObject);
//******************************************************************************
// PURPOSE: sorts tests in grdTestResults, graphs the test in row 1
//******************************************************************************
begin
  SortTests;
  grdTestResults.Row := 1;
  grdTestResultsClick(Sender);
end;

procedure TfrmMain.mnuAboutClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Create, display and free the AboutBox
//******************************************************************************
begin
  try
    frmMHA_About := TfrmMHA_About.Create(Self);
    frmMHA_About.ShowModal;
  finally
    frmMHA_About.Free;
  end;
end;

procedure TfrmMain.DisplayIncompleteTests;
//******************************************************************************
// PURPOSE: Populate string grid with list of incomplete tests
//******************************************************************************
var
  i: integer;
  tmpDate: string;
begin
  //initialize string grid for restartable tests
  with grdIncompleteTests do
  begin
    Clear;
    ColCount := 5;
    ColWidths[0] := 90;
    ColWidths[1] := 55;
    ColWidths[2] := 60;
    ColWidths[3] := 0; //restartable
    ColWidths[4] := 0; //IENS
    Cells[0, 0] := 'Date';
    Cells[1, 0] := 'Test';
    Cells[2, 0] := 'Items Answered';
    RowCount := 2;
  end;

  //get list of incomplete tests
  PatientSubSession.ListOfIncompleteTests.Assign(rMHA_VISTA.GetListOfIncompleteTests);

  if PatientSubSession.ListOfIncompleteTests[0] = '[DATA]' then
    Exit;

  //write date, test, and restartable to grdIncompleteTests
  for i := 0 to PatientSubSession.ListOfIncompleteTests.Count - 1 do
  begin
    with grdIncompleteTests do
    begin
      if i > 0 then
        RowCount := RowCount + 1;

      tmpDate := Piece(PatientSubSession.ListOfIncompleteTests[i], U, 2);
      if (pos('@', tmpDate) > 0) then
        tmpDate := Piece(tmpDate, '@', 1);
      Cells[0, i + 1] := tmpDate; //date
      Cells[1, i + 1] := Piece(PatientSubSession.ListOfIncompleteTests[i],
        U,
        1); //test code
      Cells[3, i + 1] := Piece(PatientSubSession.ListOfIncompleteTests[i],
        U,
        3); //restartable
    end;
  end;

  //Get number of answered items, IENS and clerk entry for each incomplete test
  for i := 1 to grdIncompleteTests.RowCount - 1 do
  begin
    with RPCBrokerV do
    begin
      ClearResults := True;
      ClearParameters := True;
      RemoteProcedure := 'YTAPI GET INCOMPLETE';
      Param[0].Mult['"DFN"'] := Patient.DFN;
      Param[0].Mult['"CODE"'] := grdIncompleteTests.Cells[1, i];
      Param[0].PType := List;
      call;

      // number of answered items
      if (grdIncompleteTests.Cells[1, i] = 'MCMI2')
        or (grdIncompleteTests.Cells[1, i] = 'MCMI3') then
        grdIncompleteTests.Cells[2, i] := IntToStr(pos(' ', Results[2]) - 1)
      else
        grdIncompleteTests.Cells[2, i] :=
          IntToStr(StrToInt(Piece(Results[1], U, 4)) - 1);

      //IENS
      grdIncompleteTests.Cells[4, i] := Piece(Results[1], U, 1);

      //clerk entry
      if (Piece(Results[1], U, 1) = '14') then
        grdIncompleteTests.Cells[3, i] := 'clerk';
    end;
  end;

  //sort by restartable, date
  with grdIncompleteTests do
  begin
    SortSettings.Direction := sdDescending;
    SortByColumn(0);
    SortByColumn(3);
  end;

  //Add incomplete tests to the full list
  UpdateFullTestList;

end;

procedure TfrmMain.ASITrends;
//******************************************************************************
// PURPOSE: Load ASI item data for trends report
//******************************************************************************
var
  i, ColNum, RowNum, Cellength: integer;
  strFieldCounter, tmpRead, tmpWrite, BlankLine: string;
begin
  //notify user
  StatusBarMsg(0, '  Retrieving ASI item trends data....');

  BlankLine := '                  ';
  //Setup FMGets
  with MHA_DataModule.FMGets1 do
  begin
    FieldNumbers.Clear;
    RPCBroker := RPCBrokerv;
    FileNumber := '604';
    FieldNumbers.Add('.11');

    for i := 1 to 16 do
    begin
      case i of
        1: strFieldCounter := '8.08';
        2: strFieldCounter := '9.18';
        3: strFieldCounter := '9.19';
        4: strFieldCounter := '9.25';
        5: strFieldCounter := '10.01';
        6: strFieldCounter := '10.04';
        7: strFieldCounter := '10.07';
        8: strFieldCounter := '10.15';
        9: strFieldCounter := '10.22';
        10: strFieldCounter := '10.25';
        11: strFieldCounter := '11.09';
        12: strFieldCounter := '11.11';
        13: strFieldCounter := '14.31';
        14: strFieldCounter := '18.23';
        15: strFieldCounter := '18.24';
        16: strFieldCounter := '19.23';
      end;

      FieldNumbers.Add(strFieldCounter);
    end;

  end;

  ColNum := 0;

  for RowNum := grdOldASI.RowCount - 1 downto 1 do
    //the ASI must be signed before including it in the item trends table
    if ASIIsCompleted(RowNum) then
    begin
      ColNum := ColNum + 1;
      grdASITrends.ColCount := ColNum + 1;
      //write date to item trends table
      grdASITrends.Cells[ColNum, 0] := grdOldASI.Cells[0, RowNum];

      //Get data
      MHA_DataModule.FMGets1.IENS := grdOldASI.Cells[5, RowNum];
      MHA_DataModule.FMGets1.GetData;
      //check if errors occurred during server call
      if MHA_DataModule.FMGets1.ErrorList.Count > 0 then
        MHA_DataModule.FMGets1.DisplayErrors;

      //for each of the 16 items in the table
      for i := 1 to 16 do
      begin
        case i of
          1: strFieldCounter := '8.08';
          2: strFieldCounter := '9.18';
          3: strFieldCounter := '9.19';
          4: strFieldCounter := '9.25';
          5: strFieldCounter := '10.01';
          6: strFieldCounter := '10.04';
          7: strFieldCounter := '10.07';
          8: strFieldCounter := '10.15';
          9: strFieldCounter := '10.22';
          10: strFieldCounter := '10.25';
          11: strFieldCounter := '11.09';
          12: strFieldCounter := '11.11';
          13: strFieldCounter := '14.31';
          14: strFieldCounter := '18.23';
          15: strFieldCounter := '18.24';
          16: strFieldCounter := '19.23';
        end; //case i

        //this code centers the answer in the cell
        tmpWrite := BlankLine;
        tmpRead :=
          MHA_DataModule.FMGets1.GetField(strFieldCounter).FMDBExternal;
        Cellength := Length(tmpRead);
        Insert(tmpRead, tmpWrite, 10 - Cellength);
        grdASITrends.Cells[ColNum, i] := TrimRight(tmpWrite);
      end; //for i
    end; //if grdOldASI.Cells[4, RowNum] = 'Yes' then

  //this has to be done here because fixedcols has to be less than colnum
  grdASITrends.FixedCols := 1;

  //graph first row
  grdASITrendsClick(Self);
  StatusBarMsg(0, ' ');
end;

procedure TfrmMain.InitgrdASITrends;
//******************************************************************************
// PURPOSE: Write row headings for trends report
//******************************************************************************
begin
  //load item number and Text
  with grdASITrends do
  begin
    ColCount := 1;
    ColWidths[0] := 160;
    Cells[0, 0] := 'Item';
    Cells[0, 1] := 'M6 Days medical problems';
    Cells[0, 2] := 'E11 Days worked';
    Cells[0, 3] := 'E12 Money earned';
    Cells[0, 4] := 'E17 Illegal income';
    Cells[0, 5] := 'D1 Days used alcohol';
    Cells[0, 6] := 'D2 Days alcohol intoxication';
    Cells[0, 7] := 'D3 Days used heroin';
    Cells[0, 8] := 'D5 Days used other opiates';
    Cells[0, 9] := 'D7 Days used sed/hypn/tranq';
    Cells[0, 10] := 'D8 Days used cocaine';
    Cells[0, 11] := 'D23 Money spent on alcohol';
    Cells[0, 12] := 'D24 Money spent on drugs';
    Cells[0, 13] := 'L27 Days illegal activities';
    Cells[0, 14] := 'F30 Days of family conflict';
    Cells[0, 15] := 'F31 Days of other conflict';
    Cells[0, 16] := 'P11 Days psych/emot. problems';
  end;
end;

procedure TfrmMain.StartTestEntry;
begin
  //Check to see if the MCMI2 was ordered
  MCMI2;

  //Assign selected tests to TestList
  TestList.ListOfIENS.Assign(lstTestsChosen.Items);

  //Clear the list of selected tests
  btnDeleteAll.Click;

  case TestList.TestMode of

    tmClerk:
      //Create and show the test entry form
      begin
        //create and show clerk entry form
        frmCE := TfrmCE.Create(Self);
        try
          CurrentEntryMode := emClerk;
          frmCE.ShowModal;
        finally
          frmCE.Free;
          CurrentEntryMode := emNone;
        end;

      end;

    tmPatient:
      begin
        if MsgDlg('AFTER THIS PROGRAM ENDS, IT IS GOING TO AUTOMATICALLY ' +
          'LOG YOU OFF FROM THE WINDOWS NT NETWORK' + CRLF + CRLF +
          'This is a security feature to prevent unauthorized access. You will have ' +
          'no way to stop it from logging you off.' + CRLF + CRLF +
          'Before continuing, you should complete any work that you' + #39 +
          've done in ' +
          'any other applications (Word, Outlook, etc.) and save all open data files ' +
          'in these applications. After you save your data, close those applications. ' +
          'Otherwise, you risk data loss.' + CRLF + CRLF +
          'Are you prepared to continue now?', DlgCaption, mtWarning,
          [mbYes,
          mbCancel],
            0) = mrCancel then
          exit
        else
        begin
          frmTestEntry := TfrmTestEntry.Create(Self);
          try
            CurrentEntryMode := emPatient;
            frmTestEntry.ShowModal;
          finally
            frmTestEntry.Free;
            CurrentEntryMode := emNone;
          end;
        end;
      end;

    tmStaff:
      begin
        frmTestEntry := TfrmTestEntry.Create(Self);
        try
          CurrentEntryMode := emStaff;
          frmTestEntry.ShowModal;
        finally
          frmTestEntry.Free;
          CurrentEntryMode := emNone;
        end;
      end;

  end; //Case

  //If not patient entry, then go back to test results tab and update list
  if not (TestList.TestMode = tmPatient) then
  begin
    FFirstOrderTab := True;
    FFirstTestResults := True;
    pgctrlMain.ActivePage := tbshtTestResults;
    pgctrlMainChange(Self);
    DisplayPrevTests(Self);
  end;

end;

procedure TfrmMain.StartUnsignedASI;
begin
  SaveLocationAndSize;

  with grdOldASI do
  begin

    // if ASI is signed do not show
    if (Cells[4, Row] <> 'No') then
      if (MsgDlg('A signed ASI cannot be changed or edited.', DlgCaption,
        mtWarning,
        [mbOK], 0) = mrOK) then
        exit;

    //Do not edit an unsigned ASI-MV
    //All you can do is sign it from roll-n-scroll
    if (Cells[1, Row] = 'ASI-MV') then
    begin
      SignASI_MV;
      // refresh the ASI grid
      FFirstASITab := True;
      pgctrlMain.activepage := tbshtASI;
      grdOldASI.Row := 1;
      pgctrlMainChange(Self);
      Exit;
    end;

    // This establishes the type of ASI when frmASI is created and
    // populated with data.
    FPartial_ASI := ' ';
    if Cells[1, Row] = 'Full' then
      FPartial_ASI := 'A';
    if Cells[1, Row] = 'Lite' then
      FPartial_ASI := 'L';
    if Cells[1, Row] = 'Followup' then
      FPartial_ASI := 'F';
  end; //with grdOldASI

  try
    CurrentEntryMode := emASI;
    frmASI := TfrmASI.Create(Self);
    frmASI.ShowModal;
  finally
    frmASI.Free;
    CurrentEntryMode := emNone;
  end;
  AdjustForm;

end;

procedure TfrmMain.ShowOldGafRatings;
//******************************************************************************
// PURPOSE: Makes the visual shift from GAF criteria to GAF graph
//******************************************************************************
begin
  //Change the view from GAF criteria to GAF graph
  pnlGAFCriterion.Visible := not pnlGAFCriterion.Visible;
  pnlOldGAF.Visible := not pnlOldGAF.Visible;
  pnlAllGAFCriteria.Visible := not pnlAllGAFCriteria.Visible;

  //reverse the "button" caption between "Previous Ratings" and "GAF Criteria"
  if btn1.Caption = '&Previous Ratings' then
  begin
    btn1.Caption := '&GAF Criteria';
    mnuPreviousRatings.Caption := '&GAF Criteria';
    mnuReports.Enabled := True;
    mnuGraphs.Enabled := True;
    mnuReportsPU.Enabled := True;
    mnuGraphsPU.Enabled := True;
  end
  else
  begin
    btn1.Caption := '&Previous Ratings';
    mnuPreviousRatings.Caption := '&Previous Ratings';
    mnuReports.Enabled := False;
    mnuGraphs.Enabled := False;
    mnuReportsPU.Enabled := False;
    mnuGraphsPU.Enabled := False;
  end;
  grdGAFResultsClick(Self);
end;

procedure TfrmMain.rgrpASIReportOptionClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Retrieve appropriate ASI report
//******************************************************************************
var
  ReportType, ASIIens: string;
begin

  StatusBarMsg(0, '  Retrieving ASI Report...');

  memASIReport.Clear;

  //Exit if no ASI
  if grdOldASI.Cells[0, 1] = 'None' then
  begin
    memASIReport.Lines.Add('No ASI report available.');
    Exit;
  end;

  //Determine which report to retrieve
  if rgrpASIReportOption.ItemIndex = 1 then
    ReportType := 'YSRP ASI ITEM'
  else
    ReportType := 'YSRP ASI NARRATIVE';

  ASIIens := grdOldASI.Cells[5, grdOldASI.Row];

  PatientSubsession.ASIReport.Assign(rMHA_Vista.GetASIReport(ReportType,
    ASIIens));

  if PatientSubsession.ASIReport.Count > 0 then
    memASIReport.Lines := PatientSubsession.ASIReport;
  memASIReport.SelStart := 0;

  memASIReport.Lines.Delete(0);

  memASIReport.Refresh;

  StatusBarMsg(0, '');
end;

procedure TfrmMain.grdASITrendsClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Graphs the ASI trend data
//******************************************************************************
var
  icol, irow: integer;
  CellValue: string;
begin
  irow := grdASITrends.Row;
  with chrtASITrends do
  begin
    Title.Text.Clear;
    Title.Text.Text := grdASITrends.Cells[0, irow];
    Series3.Clear;

    for icol := 1 to grdASITrends.ColCount - 1 do
    begin
      CellValue := Trim(grdASITrends.Cells[icol, irow]);
      if (Length(CellValue) > 0) and (CellValue[1] in ['0'..'9']) then
        Series3.AddXy(StrToDate(grdASITrends.Cells[icol, 0]),
          StrToInt(CellValue), grdASITrends.Cells[icol, 0], clRed);
    end;
  end;

end;

procedure TfrmMain.mnuExitClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Close form on menu exit click
//******************************************************************************
begin
  Close;
end;

procedure TfrmMain.cbxOrderedByExit(Sender: TObject);
//******************************************************************************
// PURPOSE: Force user to select an "ordered-by" person.
//******************************************************************************
begin
  if cbxOrderedBy.Text = '' then
  begin
    MsgDlg('You must specify the person requesting the test before choosing a test.',
      DlgCaption, mtWarning, [mbOK], 0);
    cbxOrderedBy.SetFocus;
  end;
end;

procedure TfrmMain.grdIncompleteTestsGetCellColor(Sender: TObject; ARow,
  ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
//******************************************************************************
// PURPOSE: use bold font for the entire row of a restartable test
//******************************************************************************
begin
  if grdIncompleteTests.Cells[3, arow] = 'restartable' then
    afont.style := [fsBold];
  if grdIncompleteTests.Cells[3, arow] = 'clerk' then
    afont.style := [];
  if grdIncompleteTests.Cells[3, arow] = 'not restartable' then
    afont.style := [fsStrikeOut];
end;

procedure TfrmMain.spnedtGAFKeyPress(Sender: TObject; var Key: Char);
//******************************************************************************
// PURPOSE: Trap invalid key strokes
//******************************************************************************
begin
  //if key is "-" or "+", then reset it to no key press
  if (key = '-') or (key = '+') then
  begin
    beep;
    key := #0;
  end;
end;

procedure TfrmMain.grdTestResultsGetCellColor(Sender: TObject; ARow,
  ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
begin
  //list exempt tests in bold font
  if (grdTestResults.Cells[2, arow] = 'P') and
    (not FHasYSP) then
    afont.Color := clBtnFace
  else
    afont.Color := clBtnText;

end;

procedure TfrmMain.grdOldASIClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Call procedures to set ASI report option and retrieve ASI report
//******************************************************************************
var
  MousePos: TPoint;
begin
  //Do this so you can return the mouse to its original position at the
  //end of this event
  MousePos := Mouse.CursorPos;

  //Retrieve ASI report
  rgrpASIReportOptionClick(Sender);
  memASIReport.Refresh;

  //reset mouse position
  Mouse.CursorPos := MousePos;
  Application.ProcessMessages;

  InitASIEditBtn;
end;

procedure TfrmMain.mnuCopyReportClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Copy to Windows clipboard.  Tab specific content
//******************************************************************************
var
  tmpMSG: string;
begin
  tmpMSG := '';

  case pgctrlMain.ActivePageIndex of
    0: //Test results tab
      begin
        with memTestResults do
        begin
          SelectAll;
          CopyToClipboard;
          SelStart := 0;
        end;
        tmpMSG := 'The test report has been copied to the Windows clipboard.'
          + CRLF + '' + CRLF
          + 'If you like, you may paste it into an open text document.'
      end; //Test results tab

    2: //ASI tab
      begin
        if pnlOldASIOuter.Visible then
        begin
          with memASIReport do
          begin
            SelectAll;
            CopyToClipboard;
            SelStart := 0;
          end;
          tmpMSG := 'The ASI report has been copied to the Windows clipboard.'
            + CRLF + '' + CRLF
            + 'If you like, you may paste it into an open text document.'
        end
        else
        begin
          grdASITrends.CopyToClipBoard;
          tmpMSG := 'The ASI item trends table has been copied to the Windows clipboard.'
            + CRLF + '' + CRLF
            + 'If you like, you may paste it into an open MS Excel worksheet.'
        end;
      end; //ASI tab

    3: //GAF tab
      begin
        grdGAFResults.CopyToClipBoard;
        tmpMSG := 'GAF ratings have been copied to the Windows clipboard.'
          + CRLF + '' + CRLF
          + 'If you like, you may paste them into an open MS Excel worksheet.'
      end; //GAF tab
  end; //case

  MsgDlg(tmpMSG, DlgCaption, mtInformation, [mbOK], 0);

end;

procedure TfrmMain.mnuCopyGraphClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Copy graphs (tab-specific) to clipboard
//******************************************************************************
var
  tmpMSG: string;
begin
  tmpMSG := '';

  case pgctrlMain.ActivePageIndex of
    0: //Test results tab
      begin
        chrtTests.CopyToClipboardBitmap;
        tmpMSG := 'The graph has been copied to the Windows clipboard.'
          + CRLF + '' + CRLF
          + 'If you like, you may paste it into an open text document.'
      end; //Test results tab

    2: //ASI tab
      begin
        if not pnlOldASIOuter.Visible then
        begin
          chrtASITrends.CopyToClipboardBitmap;
          tmpMSG := 'The ASI item trends graph has been copied to the Windows clipboard.'
            + CRLF + '' + CRLF
            + 'If you like, you may paste it into an open text document.'
        end;
      end; //ASI tab

    3: //GAF tab
      begin
        if chrtGAF.Visible then
          chrtGAF.CopyToClipboardBitmap;
        tmpMSG := 'The GAF graph has been copied to the Windows clipboard.'
          + CRLF + '' + CRLF
          + 'If you like, you may paste it into an open text document.'
      end; //GAF tab
  end;

  MsgDlg(tmpMSG, DlgCaption, mtInformation, [mbOK], 0);
  //frmMain.Left, frmMain.Top, frmMain.Height, frmMain.Width, 0);

end;

procedure TfrmMain.mnuPrintGraphClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Print tab-specific graphs
//******************************************************************************

  procedure Print(ChartName: TChart);
  begin
    with ChartName do
    begin
      Foot.Text.Text := Patient.Name;
      PrintLandscape;
      Foot.Text.Text := '';
    end;
  end;

begin
  case pgctrlMain.ActivePageIndex of
    0: Print(chrtTests); //Test results tab
    2: //ASI tab
      if not pnlOldASIOuter.Visible then
        Print(chrtASITrends);
    3: //GAF tab
      if chrtGAF.Visible then
        Print(chrtGAF);
  end;
end;

procedure TfrmMain.mnuPrintReportClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Print tab-specific reports
//******************************************************************************
var
  presX, presY: Integer;
  tmpTitle: string;
begin

  case pgctrlMain.ActivePageIndex of
    0: //Test results tab
      begin
        with memTestResults do
        begin
          Font.Size := 10;
          plaintext := true;
          presX := GetDeviceCaps(printer.handle, LOGPIXELSX);
          presY := GetDeviceCaps(printer.handle, LOGPIXELSY);
          with pagerect do
          begin
            left := 3 * presX div 4; // .75 inch left margin
            top := presY; // 1 inch top margin
            right := Printer.PageWidth - (3 * presX div 4);
            // .75 inch right margin
            bottom := Printer.PageHeight - presY; // 1 inch bottom margin
          end;
          Print('Test Report');
          Font.Size := 8;
        end;
      end; //Test results tab

    2: //ASI tab
      begin
        if pnlOldASIOuter.Visible then
        begin
          with memASIReport do
          begin
            Font.Size := 9;
            // Changed from 10 which caused excessive word-wrap
            plaintext := true;
            presX := GetDeviceCaps(printer.handle, LOGPIXELSX);
            presY := GetDeviceCaps(printer.handle, LOGPIXELSY);
            with pagerect do
            begin
              left := 3 * presX div 4; // .75 inch left margin
              top := presY; // 1 inch top margin
              right := Printer.PageWidth - (3 * presX div 4);
              // .75 inch right margin
              bottom := Printer.PageHeight - presY; // 1 inch bottom margin
            end;
            Print('ASI Report');
            Font.Size := 9;
            // Changed from 8 which caused excessive word-wrap
          end;
        end
        else
          with grdASITrends do
          begin
            tmpTitle := 'ASI Item Trends for '
              + MixedCase(Piece(Patient.Name, ',', 2))
              + ' ' + MixedCase(Piece(Patient.Name, ',', 1)) + ',  SSN: '
              + Patient.SSN;
            PrintSettings.TitleText := tmpTitle;
            Print;
          end;
      end; //ASI tab

    3: //GAF tab
      with grdGAFResults do
      begin
        tmpTitle := 'GAF Ratings for '
          + MixedCase(Piece(Patient.Name, ',', 2))
          + ' ' + MixedCase(Piece(Patient.Name, ',', 1)) + ',  SSN: '
          + Patient.SSN;
        PrintSettings.TitleText := tmpTitle;
        Print;
      end; //GAF tab
  end; //case

end;

procedure TfrmMain.mnuSaveGraphAsClick(Sender: TObject);
//******************************************************************************
// PURPOSE: Save tab-specific graphs to bmp files
//******************************************************************************
begin
  with MHA_DataModule.dlgSave do
    case pgctrlMain.ActivePageIndex of
      0: //Test results tab
        begin
          FileName := 'Test Scores.bmp';
          Filter := 'Bitmap files (*.bmp)|*.bmp';
          if Execute then
            chrtTests.SaveToBitmapFile(MHA_DataModule.dlgSave.FileName);
        end; //Test results tab

      2: //ASI tab
        begin
          if not pnlOldASIOuter.Visible then
          begin
            FileName := 'ASI Item Trends.bmp';
            Filter := 'Bitmap files (*.bmp)|*.bmp';
            if Execute then
              chrtASITrends.SaveToBitmapFile(MHA_DataModule.dlgSave.FileName);
          end;
        end; //ASI tab

      3: //GAF tab
        begin
          if chrtGAF.Visible then
          begin
            FileName := 'GAF Ratings.bmp';
            Filter := 'Bitmap files (*.bmp)|*.bmp';
            if Execute then
              chrtGAF.SaveToBitmapFile(MHA_DataModule.dlgSave.FileName);
          end;
        end; //GAF tab

    end; //case

end;

procedure TfrmMain.grdASITrendsClickCell(Sender: TObject; arow,
  acol: Integer);
//******************************************************************************
// PURPOSE: Select row from fixed column.
//******************************************************************************
begin
  if arow = 0 then
    exit;

  if acol = 0 then
    grdASITrends.row := arow;
end;

procedure TfrmMain.mnuSaveReportAsClick(Sender: TObject);
begin
  with MHA_DataModule.dlgSave do
    case pgctrlMain.ActivePageIndex of
      0: //Test results tab
        begin
          FileName := 'Test Report.rtf';
          Filter := 'Rich text file (*rtf)|*.rtf';
          if Execute then
            memTestResults.Lines.SaveToFile(MHA_DataModule.dlgSave.FileName);
        end; //Test results tab

      2: //ASI tab
        begin
          if pnlOldASIOuter.Visible then
          begin
            FileName := 'ASI Report.rtf';
            Filter := 'Rich text file (*rtf)|*.rtf';
            if Execute then
              memASIReport.Lines.SaveToFile(MHA_DataModule.dlgSave.FileName);
          end
          else
          begin
            FileName := 'ASI Item Trends.xls';
            Filter := 'Excel file (*xls)|*.xls';
            if Execute then
              grdASITrends.SaveToXLS(MHA_DataModule.dlgSave.FileName);
          end;
        end; //ASI tab

      3: //GAF tab
        begin
          if pnlOldGAF.Visible then
          begin
            FileName := 'GAF Ratings.xls';
            Filter := 'Excel file (*xls)|*.xls';
            if Execute then
              grdGAFResults.SaveToXLS(MHA_DataModule.dlgSave.FileName);
          end;
        end; //GAF tab

    end; //case

end;

procedure TfrmMain.mnuShowHintsClick(Sender: TObject);
begin
  mnuShowHints.Checked := not mnuShowHints.Checked;
  Application.ShowHint := mnuShowHints.Checked;
end;

procedure TfrmMain.ShowHint(Sender: TObject);
begin
  //Application.ShowHint := true;
  //lblHint.Caption := GetLongHint(Application.Hint);
end;

procedure TfrmMain.grdOldASIDblClick(Sender: TObject);
begin
  StartUnsignedASI;
end;

procedure TfrmMain.lstTestChoicesClick(Sender: TObject);
begin
  with lstTestChoices do
    HelpContext := ContextID(Piece(Items[ItemIndex], U, 2));

  lstTestsChosen.ItemIndex := -1;
  SetTestSelectionButtons;
end;

procedure TfrmMain.AdjustForm;
var
  r: TRect;
begin
  if mnuDefaultFormSizes.Checked then
  begin
    SystemParametersInfo(SPI_GetWorkArea, 0, @r, 0);
    BoundsRect := r;
    Top := r.Top;
    Height := r.Bottom - r.Top;
    Left := r.Left;
    Width := r.Right - r.Left;
  end
  else
    // Larger screen configurations
  begin
    MHA_Registry.ReadRegistry;
    WindowState := wsNormal;
    Top := MHA_Registry.MainTop; // from Windows registry
    Left := MHA_Registry.MainLeft;
    Height := MHA_Registry.MainHeight;
    Width := MHA_Registry.MainWidth;
  end;
end;

procedure TFrmMain.SaveLocationAndSize;
begin
  MHA_Registry.MainTop := Top;
  MHA_Registry.MainLeft := Left;
  MHA_Registry.MainHeight := Height;
  MHA_Registry.MainWidth := Width;
  MHA_Registry.SaveRegistry;
end;

procedure TfrmMain.lstTestBatteriesDblClick(Sender: TObject);
var
  tmpBattery, tmpName: string;
  i, Index, NumPieces: integer;
begin
  Index := lstTestBatteries.ItemIndex;
  if Index < 0 then
    exit;

  tmpBattery := lstTestBatteries.Items[Index];

  NumPieces := 0;
  for i := 0 to length(tmpBattery) do
    if copy(tmpBattery, i, 1) = U then
      inc(NumPieces);

  for i := 2 to NumPieces + 1 do
  begin
    tmpName := Piece(tmpBattery, U, i);
    if (lstTestChoices.Items.IndexOf(tmpName) = -1) then
      if (lstTestsChosen.Items.IndexOf(tmpName) = -1) then
        ShowMessage(tmpName + ' not available')
      else
        ShowMessage(tmpName + ' has already been selected')
    else
    begin
      lstTestChoices.ItemIndex := lstTestChoices.Items.IndexOf(tmpName);
      btnSelectTestClick(Self);
    end;
  end;

  // lstTestBatteries.Items.Delete(Index);  commented this out per Bill Bell's suggestion
  StatusBarMsg(0, '');
  lstTestBatteries.Hint :=
    'Click on a battery to see the tests it includes';
  SetTestSelectionButtons;
end;

procedure TfrmMain.lstTestBatteriesClick(Sender: TObject);
var
  tmpBattery, tmpNames: string;
  i, NumPieces: integer;
begin
  i := lstTestBatteries.ItemIndex;
  //exit if the click was not on an item
  if i < 0 then
    exit;

  SetTestSelectionButtons;

  tmpBattery := lstTestBatteries.Items[i];
  tmpNames := ' ' + Piece(tmpBattery, U, 1) + ' Tests:';

  NumPieces := 0;
  for i := 0 to length(tmpBattery) do
    if copy(tmpBattery, i, 1) = U then
      inc(NumPieces);

  for i := 2 to NumPieces + 1 do
    tmpNames := tmpNames + ' ' + Piece(tmpBattery, U, i);

  lstTestBatteries.Hint := tmpNames;
  StatusBarMsg(0, tmpNames);

end;

function TfrmMain.ContextID(tmpName: string): integer;
begin
  //The context id of the table of test names in the help file is 799
  Result := 799;
  if tmpName = 'ATQ' then
    Result := 800;
  if tmpName = 'AUDC' then
    Result := 801;
  if tmpName = 'AUDCR' then
    Result := 802;
  if tmpName = 'AUDIT' then
    Result := 803;
  if tmpName = 'AUIR' then
    Result := 804;
  if tmpName = 'BAI' then
    Result := 805;
  if tmpName = 'BDI' then
    Result := 806;
  if tmpName = 'BHS' then
    Result := 807;
  if tmpName = 'BPRS' then
    Result := 808;
  if tmpName = 'BSI' then
    Result := 809;
  if tmpName = 'CAGE' then
    Result := 810;
  if tmpName = 'CRS' then
    Result := 811;
  if tmpName = 'ERS' then
    Result := 812;
  if tmpName = 'HLOC' then
    Result := 813;
  if tmpName = 'ICL' then
    Result := 814;
  if tmpName = 'IEQ' then
    Result := 815;
  if tmpName = 'JENK' then
    Result := 816;
  if tmpName = 'MATE' then
    Result := 817;
  if tmpName = 'MCMI2' then
    Result := 818;
  if tmpName = 'MHLA' then
    Result := 819;
  if tmpName = 'MHLB' then
    Result := 820;
  if tmpName = 'MHLC' then
    Result := 821;
  //Context ID 822 was accidentally left out of the help file
  //no problem, though.  Just skip it.
  if tmpName = 'MILL' then
    Result := 823;
  if tmpName = 'MISS' then
    Result := 824;
  if tmpName = 'MMPI2' then
    Result := 825;
  if tmpName = 'NEOPI' then
    Result := 826;
  if tmpName = 'PAI' then
    Result := 827;
  if tmpName = 'PCLC' then
    Result := 828;
  if tmpName = 'PCLM' then
    Result := 829;
  if tmpName = 'RLOC' then
    Result := 830;
  if tmpName = 'SAI' then
    Result := 831;
  if tmpName = 'SCL9R' then
    Result := 832;
  if tmpName = 'SDES' then
    Result := 833;
  if tmpName = 'SF36' then
    Result := 834;
  if tmpName = 'SMAST' then
    Result := 835;
  if tmpName = 'STAI' then
    Result := 836;
  if tmpName = 'SWS' then
    Result := 837;
  if tmpName = 'VALD' then
    Result := 838;
  if tmpName = 'ZUNG' then
    Result := 839;

  //new tests, out of alphabetical order
  if tmpName = 'BDI2' then
    Result := 840;
  if tmpName = 'BSI18' then
    Result := 841;
  if tmpName = 'MBMD' then
    Result := 842;
  if tmpName = 'MCMI3' then
    Result := 843;
end;

procedure TfrmMain.mnuTestInfoClick(Sender: TObject);
var
  tmpName: string;
begin
  tmpName := 'NONE';

  if (pgctrlMain.ActivePage = tbshtTestResults) then
    tmpName := grdTestResults.Cells[1, grdTestResults.Row];

  if (pgctrlMain.ActivePage = tbshtOrderTests) then
  begin

    {*First look to see if the list of chosen tests has focus and one of the
    chosen tests has been highlighted.  If both are true, assume that is the
    test the user wants to know about.
    If one of the first pair of conditions is not true, look second to see
    if one of the available tests is highlisted.  If so, assume that is the
    test the user wants to know about.
    If neither the first or second "if" is true, assume the user doesn't
    have a particular test in mind and leave tmpName = 'NONE', which will
    open the help file at the table of test names*}
    if lstTestsChosen.ItemIndex > -1 then
      tmpName := Piece(lstTestsChosen.Items[lstTestsChosen.ItemIndex], U, 2)
    else if lstTestChoices.ItemIndex > -1 then
      tmpName := Piece(lstTestChoices.Items[lstTestChoices.ItemIndex], U,
        2);

    //drop the '*' if it is a restartable test
    if pos('*', tmpName) > 0 then
      tmpName := copy(tmpName, 1, Length(tmpName) - 1);

  end;

  Application.HelpContext(ContextID(tmpName));

end;

procedure TfrmMain.FormResize(Sender: TObject);
begin
  ResizeGafCriteria;
  InitgrdOldASI;
  PositionTopButtons;
end;

procedure TfrmMain.grdIncompleteTestsDblClick(Sender: TObject);
var
  tmpTest, Status: string;
  Ordered: Boolean;
begin
  tmpTest := Trim(grdIncompleteTests.Cells[1, grdIncompleteTests.Row]);

  if (tmpTest = '') then
    exit;

  Status := grdIncompleteTests.Cells[3, grdIncompleteTests.Row];

  if (Status = 'restartable') then
  begin
    tmpTest := tmpTest + '*';
  end;

  if (Status = 'not restartable') then
  begin
    Ordered := (lstTestsChosen.Items.IndexOf(tmpTest) > -1);
    if Ordered then
    begin
      MsgDlg('This ' + tmpTest +
        ' was begun too long ago to restart.  A new '
        + tmpTest + ' already has been ordered.', DlgCaption, mtInformation,
        [mbOK], 0);
      Exit;
    end
    else if (MsgDlg('This ' + tmpTest +
      ' was begun too long ago to restart.  Do you '
      + 'want to start a new ' + tmpTest + '?', DlgCaption, mtConfirmation,
      [mbYes, mbNo], 0) = mrNo) then
      Exit;
  end;

  if (Status = 'clerk') then
  begin
    MsgDlg('This ' + tmpTest + ' was begun using the clerk entry option '
      + 'in the roll-and-scroll version of the Mental Health Package.  '
      + 'You will have to use that option to complete the test.',
      DlgCaption, mtInformation, [mbOK], 0);
    Exit;

  end;

  lstTestChoices.ItemIndex := lstTestChoices.Items.IndexOf(tmpTest);
  btnSelectTestClick(Sender);

end;

procedure TfrmMain.mnuStartTabClick(Sender: TObject);
begin
  try
    frmMHA_Options := TfrmMHA_Options.Create(Self);
  finally
    frmMHA_Options.Free;
  end;
end;

procedure TfrmMain.mnuDefaultFormSizesClick(Sender: TObject);
begin
  mnuDefaultFormSizes.Checked := not mnuDefaultFormSizes.Checked;
  AdjustForm;
end;

procedure TfrmMain.lstTestsChosenClick(Sender: TObject);
begin
  with lstTestsChosen do
    HelpContext := ContextID(Piece(Items[ItemIndex], U, 2));

  lstTestChoices.ItemIndex := -1;
  SetTestSelectionButtons;
end;

procedure TfrmMain.grdGAFResultsClick(Sender: TObject);
begin

  btn3.Enabled := False;
  mnuEditRating.Enabled := False;

  with grdGAFResults do
  begin
    if pnlOldGAF.Visible
      and (UpperCase(User.Name) = UpperCase(Cells[2, Row]))
      and not (Cells[4, Row] = 'ERROR') then
    begin
      btn3.Enabled := True;
      mnuEditRating.Enabled := True;
    end; //if
  end; //with
end;

procedure TfrmMain.grdGAFResultsGetCellColor(Sender: TObject; ARow,
  ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
begin
  if grdGAFResults.Cells[4, ARow] = 'ERROR' then
    AFont.Style := [fsStrikeOut];

end;

procedure TfrmMain.btnEditASIClick(Sender: TObject);
begin
  if btnEditASI.Enabled then
    StartUnsignedASI;
end;

procedure TfrmMain.mnuGAFClick(Sender: TObject);
begin
  with pgctrlMain do
  begin
    ActivePage := tbshtGAF;
    pgctrlMainChange(Self);
  end;
end;

procedure TfrmMain.mnuTestResultsClick(Sender: TObject);
begin
  with pgctrlMain do
  begin
    ActivePage := tbshtTestResults;
    pgctrlMainChange(Self);
  end;
end;

procedure TfrmMain.mnuOrderTestsClick(Sender: TObject);
begin
  with pgctrlMain do
  begin
    ActivePage := tbshtOrderTests;
    pgctrlMainChange(Self);
  end;
end;

procedure TfrmMain.mnuASIClick(Sender: TObject);
begin
  with pgctrlMain do
  begin
    ActivePage := tbshtASI;
    pgctrlMainChange(Self);
  end;
end;

procedure TfrmMain.lstTestChoicesKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  with lstTestChoices do
  begin
    if (Key = vk_Up) and not (ItemIndex < 1) then
      ItemIndex := ItemIndex - 1;
    if (Key = vk_Down) and not (ItemIndex = Items.Count - 1) then
      ItemIndex := ItemIndex + 1;
    SetTestSelectionButtons;
  end;
end;

procedure TfrmMain.lstTestsChosenKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  with lstTestsChosen do
  begin
    if (Key = vk_Up) and not (ItemIndex < 1) then
      ItemIndex := ItemIndex - 1;
    if (Key = vk_Down) and not (ItemIndex = Items.Count - 1) then
      ItemIndex := ItemIndex + 1;
    SetTestSelectionButtons;
  end;
end;

procedure TfrmMain.lstTestBatteriesKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  with lstTestBatteries do
  begin
    if (Key = vk_Up) and not (ItemIndex < 1) then
      ItemIndex := ItemIndex - 1;
    if (Key = vk_Down) and not (ItemIndex = Items.Count - 1) then
      ItemIndex := ItemIndex + 1;
    SetTestSelectionButtons;
  end;
end;

procedure TfrmMain.btnGAFDueClick(Sender: TObject);
begin
  if
    (MsgDlg('This patient has not had an outpatient GAF in the past 90 days.  Would '
    + 'you like to do a GAF rating now?', DlgCaption, mtConfirmation,
    [mbYes, mbNo], 0)) = mrYes then
  begin
    pgctrlMain.ActivePage := tbshtGAF;
    pgctrlMainChange(Self);
  end;
end;

procedure TfrmMain.btn2Click(Sender: TObject);
begin

  SaveLocationAndSize;

  //tab-specific actions
  case pgctrlMain.ActivePageIndex of
    0: //Test results tab
      begin
        //create and show form to graph multi-scale tests
        frmReport := TfrmReport.Create(Self);
        try
          frmReport.ShowModal;
        finally
          frmReport.Free;
        end;
        AdjustForm;
      end; //Test results tab

    1: //Test order tab, clerk entry of test data
      begin
        if
          MsgDlg('This option is for staff use only.  Using it with patients '
          + 'is likely to result in '
          + 'a serious breach of confidentiality.'
          + CRLF + '' + CRLF
          + 'Are you sure you want to use the clerk-entry mode?',
          DlgCaption, mtWarning, [mbYes, mbNo], 0) = mrNo then
          exit;

        TestList.TestMode := tmClerk;
        StartTestEntry;
        AdjustForm;
      end; //Test order tab, clerk entry of test data

    2: //ASI Results tab
      begin
        StatusBarMsg(0, '  Retrieving ASI Severity Ratings...');

        //create and show form to graph ASI severity ratings
        frmTestGraph := TfrmTestGraph.Create(Self);
        try
          frmTestGraph.ShowModal;
        finally
          frmTestGraph.Free;
        end;
        AdjustForm;
        StatusBarMsg(0, '');
      end; //ASI Results tab

    3: //GAF tab, save GAF rating
      begin

        //Check to see if pt is deceased, then check to see if data entry OK
        with PatientSubSession do
          if PatientIsDead then
            if not DeceasedPatientDataEntryOK('GAF') then
              exit;

        rMHA_Vista.SaveGAFScore(Patient.DFN, spnedtGAF.Text,
          DateToStr(dtpkrEval.Date), IntToStr(User.DUZ));

        //Update list of previous GAFs and GAF graph, show graph
        spnedtGAF.Value := 1;
        DisplayPrevGAFs;
        GraphGafData;
        grdGAFResultsClick(Self);
        if btn1.Caption = '&Previous Ratings' then
          ShowOldGafRatings;

        //Disable save GAF "button"
        btn2.Enabled := False;
        mnuSaveRating.Enabled := False;

        //GAF no longer due
        GafNotDue;
      end; //GAF tab, save GAF rating
  end; //Case

end;

procedure TfrmMain.btn3Click(Sender: TObject);
var
  GAFDate: TDateTime;
  DaysSinceGAFEntry: integer;
begin

  SaveLocationAndSize;

  case pgctrlMain.ActivePageIndex of
    0: //Test results tab
      begin
        //create and show form to append comments
        frmAppendTestComments := TfrmAppendTestComments.Create(Self);
        try
          frmAppendTestComments.ShowModal;
        finally
          frmAppendTestComments.Free;
        end;
        //update test report
        grdTestResultsClick(Self);
        AdjustForm;
      end; //Test results tab

    1: //Test order tab
      begin
        TestList.TestMode := tmPatient;
        StartTestEntry;
      end; //Test order tab

    2: //ASI tab
      begin
        if btn3.Caption = '&Item Trends' then
        begin

          btn3.Caption := '&ASI Reports';
          mnuItemTrends.Caption := '&ASI Reports';
          pnlOldASIOuter.Visible := False;
          pnlASITrends.Visible := True;
          ASITrends;
          mnuGraphs.Enabled := True;
          mnuGraphsPU.Enabled := True;

        end
        else
        begin
          btn3.Caption := '&Item Trends';
          mnuItemTrends.Caption := '&Item Trends';
          pnlOldASIOuter.Visible := True;
          pnlASITrends.Visible := False;
          mnuGraphs.Enabled := False;
          mnuGraphsPU.Enabled := False;
        end;
      end; //ASI tab

    3: //GAF tab
      begin

        with grdGAFResults do
        begin

          GAFDate := StrToDate(Cells[0, Row]);
          DaysSinceGAFEntry := DaysApart(GAFDate, Now);

          case DaysSinceGAFEntry of
            0..2:
              begin
                frmEditGAF := TfrmEditGAF.Create(Self);
                try
                  frmEditGAF.ShowModal;
                finally
                  frmEditGAF.Free;
                end; //try

              end; //case 0..2
          else
            begin
              Beep;
              if (MsgDlg('You are about to mark the GAF entered on '
                + Cells[0, Row] + ' as "Entered in Error."  If you '
                + 'make this change, you will not be able to undo it.'
                + CRLF + CRLF + 'Do you want to continue?', DlgCaption,
                mtWarning, [mbOK, mbCancel], 0) = mrOK) then
              begin
                rMHA_Vista.MarkGAFInError(grdGAFResults.Cells[3,
                  grdGAFResults.Row]); //IENS
                DisplayPrevGAFs;
                GraphGAFData;
              end //if msgdlg = mrOK
              else
                Exit;
            end; //else case DaysSinceGAFEntry

          end; //case DaysSinceGAFEntry

          DisplayPrevGAFs;
          GraphGAFData;

        end; //with grdGAFResults

      end; //GAF tab
  end; //case ActivePageIndex

end;

procedure TfrmMain.btn1Click(Sender: TObject);

  procedure AskWhichMMPITypes(SelectedType: string);
  const
    TmpMsg = 'Do you want to include both the MMPI2 and the MMP2S?';
  var
    irow: integer;
    OtherType: string;
    BothTypesExist: BOOLEAN;
  begin
    if (SelectedType = 'MMPI2') then
      OtherType := 'MMP2S'
    else
      OtherType := 'MMPI2';

    BothTypesExist := False;

    with grdTestResults do
      for irow := 1 to RowCount - 1 do
        if (Cells[1, irow] = OtherType) then
          BothTypesExist := True;

    if BothTypesExist then
      GraphBothMMPITypes := (MsgDlg(TmpMsg, DlgCaption, mtConfirmation,
        [mbYes, mbNo], 0) = mrYes);

  end; //AskWhichMMPITypes

begin

  SaveLocationAndSize;

  //tab-specific actions
  case pgctrlMain.ActivePageIndex of
    0: //Test results tab
      begin
        if (grdTestResults.Cells[1, grdTestResults.Row] = 'MMPI2')
          or (grdTestResults.Cells[1, grdTestResults.Row] = 'MMP2S') then
          AskWhichMMPITypes(grdTestResults.Cells[1, grdTestResults.Row])
        else
          GraphBothMMPITypes := False;

        //create and show form to graph multi-scale tests
        frmTestGraph := TfrmTestGraph.Create(Self);
        try
          frmTestGraph.ShowModal;
        finally
          frmTestGraph.Free;
        end;
        AdjustForm;
      end; //Test results tab

    1: //Test order tab, staff-entry of test data
      begin
        if
          MsgDlg('This option is for staff use only.  Using it with patients '
          + 'is likely to result in '
          + 'a serious breach of confidentiality.'
          + CRLF + '' + CRLF
          + 'Are you sure you want to use the staff-entry mode?',
          DlgCaption, mtWarning, [mbYes, mbNo], 0) = mrNo then
          exit
        else
        begin
          TestList.TestMode := tmStaff;
          StartTestEntry;
          AdjustForm;
        end;
      end; //Test order tab, staff-entry of test data

    2: //ASI results tab, launch ASI data entry form
      begin
        //Check to see if pt is deceased, then check to see if data entry OK
        with PatientSubSession do
          if PatientIsDead then
            if not DeceasedPatientDataEntryOK('ASI') then
              exit;

        try
          CurrentEntryMode := emASI;
          FPartial_ASI := ' ';
          frmASI := TfrmASI.Create(Self);
          frmASI.ShowModal;
        finally
          frmASI.Free;
          CurrentEntryMode := emNone;
        end;
        AdjustForm;
      end; //ASI results tab, launch ASI data entry form

    3: ShowOldGafRatings; //GAF tab

  end; //case

end;

procedure TfrmMain.PositionTopButtons;
var
  space, BtnWidth: integer;
begin
  BtnWidth := (pnlButtons.Width - 10) div 5;
  space := (pnlButtons.Width - (5 * BtnWidth)) div 6;
  btnPatient.Width := BtnWidth;
  btn1.Width := BtnWidth;
  btn2.Width := BtnWidth;
  btn3.Width := BtnWidth;
  btnGAFDue.Width := BtnWidth;
  btnPatient.Left := pnlButtons.Left + space;
  btn1.Left := btnPatient.Left + btnPatient.Width + space;
  btn2.Left := btn1.Left + BtnWidth + space;
  btn3.Left := btn2.Left + BtnWidth + space;
  btnGAFDue.Left := btn3.Left + BtnWidth + space;
end;

procedure TfrmMain.btnPatientClick(Sender: TObject);
begin
  //create and show form to display demographics
  frmPatientDemographics := TfrmPatientDemographics.Create(Self);
  try
    frmPatientDemographics.ShowModal;
  finally
    frmPatientDemographics.Release;
  end;
end;

procedure TfrmMain.FormContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
  mnuBtn1PU.Caption := btn1.Caption;
  mnuBtn1PU.Visible := btn1.Enabled;
  mnuBtn2PU.Caption := btn2.Caption;
  mnuBtn2PU.Visible := btn2.Enabled;
  mnuBtn3PU.Caption := btn3.Caption;
  mnuBtn3PU.Visible := btn3.Enabled;
end;

procedure TfrmMain.SignASI_MV;
var
  Sig,
    MySig: string;

  function GetElectronicSignature: string;
  begin
    SignatureForASI(Font.Size,
      'Sign the Addiction Severity Index',
      'Electronic Signature',
      MySig);
    if MySig = '' then
    begin
      result := 'Cancel';
      exit;
    end;

    with RPCBrokerV do
    begin
      ClearResults := True;
      ClearParameters := True;
      RemoteProcedure := 'YTAPI ASI SIGNER';
      Param[0].Mult['"CODE"'] := MySig;
      Param[0].Mult['"YSIEN"'] := grdOldASI.Cells[5, grdOldASI.Row];
      Param[0].PType := List;
      call;
    end;

    if RPCBrokerV.Results[1] = '1^ASI SIGNED' then
      result := 'Done'
    else
      result := 'Error';
  end;

begin
  // Ensure that the interviewer is the person signing this ASI.
  if UpperCase(Trim(User.Name)) <>
    UpperCase(Trim(grdOldASI.Cells[2, grdOldASI.Row])) then
  begin
    MsgDlg('The only person allowed to sign this ASI is the interviewer.',
      'Electronic Signature', mtInformation, [mbOK], 0);
    //Left, Top, Height, Width, 0);
    exit;
  end;

  // User signs ASI-MV
  repeat
    Sig := GetElectronicSignature;
    if sig = 'Cancel' then
      exit;
    if Sig = 'Done' then
      exit;
    MsgDlg('This signature was not recognized. Capitalization may be required. '
      +
      'Please try again.',
      'Electronic Signature', mtInformation, [mbOK], 0);
    //Left, Top, Height, Width, 0);
  until sig = 'Done';
end;

procedure TfrmMain.StatusBarMsg(Panel: integer; Msg: string);
begin
  stsbrMain.Panels[Panel].Text := Msg;
  Application.ProcessMessages;
end;

procedure TfrmMain.mnuRefreshClick(Sender: TObject);
begin
  //Clear previous patient's results
  grdTestResults.Clear;
  memTestResults.Clear;
  chrtTests.Series[0].Clear;
  memASIReport.Clear;
  grdOldASI.Clear;
  grdGAFResults.Clear;
  chrtGAF.Series[0].Clear;

  Application.ProcessMessages;

  //reset first tab vars to true
  //tracks first tab visit for selected patient
  FFirstTestResults := True;
  FFirstOrderTab := True;
  FFirstGAFTab := True;
  FFirstASITab := True;

  //call procedure to retrieve previous GAF ratings from VISTA
  DisplayPrevGAFs;
  GAFReminder;

  with pgctrlMain do
  begin
    if MHA_Registry.MainTabOrder < 0 then
      ActivePageIndex := 0;
    if MHA_Registry.MainTabOrder > 9 then
      ActivePageIndex := MHA_Registry.MainTabOrder - 10
    else
      ActivePageIndex := MHA_Registry.MainTabOrder;
  end; //with pgctrlMain

  SetupTabs(sender);

end;

end.

