{***************************************************************

 UNIT NAME: uMHA_Entities
 PACKAGE: Mental Health Package
 WARNING:
 DATE CREATED: Jan 1, 2001
 SITE NAME: Salt Lake City Mental Health Informatics Section
 DEVELOPERS: R. FELDMAN
 DESCRIPTION: Object business classes that are entities.
 NOTE: This unit requires Mental Health patch 67, or greater, in
       order to run.

 HISTORY  :

 Required third-party Delphi components and libraries:


****************************************************************}
unit uMHA_Entities;

interface
uses uCore, Classes;

type
  TTestOrderer = class
  private
    FDUZ: Int64;
    FHasYSPKey: Boolean;
    FName: string;
    FOrderableTests: TStrings;
    FFirstOrderer: String;

  protected

  public
    constructor Create;
    destructor Destroy; override;
    property DUZ: Int64 read FDUZ write FDUZ;
    property HasYSPKey: Boolean read FHasYSPKey write FHasYSPKey;
    property Name: string read FName write FName;
    property OrderableTests: TStrings read FOrderableTests write
      FOrderableTests;
    property FirstOrderer: String read FFirstOrderer write FFirstOrderer;

  published

  end;

implementation

//******************************************************************************
// TTestOrderer.Create [X]USED [X]DONE [X]TESTED
// PURPOSE: Initialize this object
// AUTHOR: Feldman-Cannon // REVIEWER: Feldman-Cannon
// LAST MODIFICATION/REVIEW DATE: 02/16/01
//******************************************************************************
constructor TTestOrderer.Create;
begin
  inherited Create;
  FOrderableTests := TStringList.Create;
end;

//******************************************************************************
// TTestOrderer.Destroy [X]USED [X]DONE [X]TESTED
// PURPOSE: Destroy this object
// AUTHOR: Feldman-Cannon // REVIEWER: Feldman-Cannon
// LAST MODIFICATION/REVIEW DATE: 02/16/01
//******************************************************************************
destructor TTestOrderer.Destroy;
begin
  FOrderableTests.Free;
  inherited Destroy;
end;

end.

